/* Generated by re2c 0.14.3 */
/*
   +----------------------------------------------------------------------+
   | Zend Engine                                                          |
   +----------------------------------------------------------------------+
   | Copyright (c) Zend Technologies Ltd. (http://www.zend.com)           |
   +----------------------------------------------------------------------+
   | This source file is subject to version 2.00 of the Zend license,     |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.zend.com/license/2_00.txt.                                |
   | If you did not receive a copy of the Zend license and are unable to  |
   | obtain it through the world-wide-web, please send a note to          |
   | license@zend.com so we can mail you a copy immediately.              |
   +----------------------------------------------------------------------+
   | Authors: Marcus Boerger <helly@php.net>                              |
   |          Nuno Lopes <nlopess@php.net>                                |
   |          Scott MacVicar <scottmac@php.net>                           |
   | Flex version authors:                                                |
   |          Andi Gutmans <andi@php.net>                                 |
   |          Zeev Suraski <zeev@php.net>                                 |
   +----------------------------------------------------------------------+
*/

#if 0
# define YYDEBUG(s, c) printf("state: %d char: %c\n", s, c)
#else
# define YYDEBUG(s, c)
#endif

#include "zend_language_scanner_defs.h"

#include <errno.h>
#include "zend.h"
#ifdef ZEND_WIN32
# include <Winuser.h>
#endif
#include "zend_alloc.h"
#include <zend_language_parser.h>
#include "zend_compile.h"
#include "zend_language_scanner.h"
#include "zend_highlight.h"
#include "zend_constants.h"
#include "zend_variables.h"
#include "zend_operators.h"
#include "zend_API.h"
#include "zend_strtod.h"
#include "zend_exceptions.h"
#include "zend_virtual_cwd.h"

#define YYCTYPE   unsigned char
#define YYFILL(n) { if ((YYCURSOR + n) >= (YYLIMIT + ZEND_MMAP_AHEAD)) { return 0; } }
#define YYCURSOR  SCNG(yy_cursor)
#define YYLIMIT   SCNG(yy_limit)
#define YYMARKER  SCNG(yy_marker)

#define YYGETCONDITION()  SCNG(yy_state)
#define YYSETCONDITION(s) SCNG(yy_state) = s

#define STATE(name)  yyc##name

/* emulate flex constructs */
#define BEGIN(state) YYSETCONDITION(STATE(state))
#define YYSTATE      YYGETCONDITION()
#define yytext       ((char*)SCNG(yy_text))
#define yyleng       SCNG(yy_leng)
#define yyless(x)    do { YYCURSOR = (unsigned char*)yytext + x; \
                          yyleng   = (unsigned int)x; } while(0)
#define yymore()     goto yymore_restart

/* perform sanity check. If this message is triggered you should
   increase the ZEND_MMAP_AHEAD value in the zend_streams.h file */
#define YYMAXFILL 16
#if ZEND_MMAP_AHEAD < YYMAXFILL
# error ZEND_MMAP_AHEAD should be greater than or equal to YYMAXFILL
#endif

#include <stdarg.h>

#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif

/* Globals Macros */
#define SCNG	LANG_SCNG
#ifdef ZTS
ZEND_API ts_rsrc_id language_scanner_globals_id;
ZEND_API size_t language_scanner_globals_offset;
#else
ZEND_API zend_php_scanner_globals language_scanner_globals;
#endif

#define HANDLE_NEWLINES(s, l)													\
do {																			\
	char *p = (s), *boundary = p+(l);											\
																				\
	while (p<boundary) {														\
		if (*p == '\n' || (*p == '\r' && (*(p+1) != '\n'))) {					\
			CG(zend_lineno)++;													\
		}																		\
		p++;																	\
	}																			\
} while (0)

#define HANDLE_NEWLINE(c) \
{ \
	if (c == '\n' || c == '\r') { \
		CG(zend_lineno)++; \
	} \
}

/* To save initial string length after scanning to first variable */
#define SET_DOUBLE_QUOTES_SCANNED_LENGTH(len) SCNG(scanned_string_len) = (len)
#define GET_DOUBLE_QUOTES_SCANNED_LENGTH()    SCNG(scanned_string_len)

#define IS_LABEL_START(c) (((c) >= 'a' && (c) <= 'z') || ((c) >= 'A' && (c) <= 'Z') || (c) == '_' || (c) >= 0x80)
#define IS_LABEL_SUCCESSOR(c) (((c) >= 'a' && (c) <= 'z') || ((c) >= 'A' && (c) <= 'Z') || ((c) >= '0' && (c) <= '9') || (c) == '_' || (c) >= 0x80)

#define ZEND_IS_OCT(c)  ((c)>='0' && (c)<='7')
#define ZEND_IS_HEX(c)  (((c)>='0' && (c)<='9') || ((c)>='a' && (c)<='f') || ((c)>='A' && (c)<='F'))


static void strip_underscores(char *str, size_t *len)
{
	char *src = str, *dest = str;
	while (*src != '\0') {
		if (*src != '_') {
			*dest = *src;
			dest++;
		} else {
			--(*len);
		}
		src++;
	}
	*dest = '\0';
}

static size_t encoding_filter_script_to_internal(unsigned char **to, size_t *to_length, const unsigned char *from, size_t from_length)
{
	const zend_encoding *internal_encoding = zend_multibyte_get_internal_encoding();
	ZEND_ASSERT(internal_encoding);
	return zend_multibyte_encoding_converter(to, to_length, from, from_length, internal_encoding, LANG_SCNG(script_encoding));
}

static size_t encoding_filter_script_to_intermediate(unsigned char **to, size_t *to_length, const unsigned char *from, size_t from_length)
{
	return zend_multibyte_encoding_converter(to, to_length, from, from_length, zend_multibyte_encoding_utf8, LANG_SCNG(script_encoding));
}

static size_t encoding_filter_intermediate_to_script(unsigned char **to, size_t *to_length, const unsigned char *from, size_t from_length)
{
	return zend_multibyte_encoding_converter(to, to_length, from, from_length,
LANG_SCNG(script_encoding), zend_multibyte_encoding_utf8);
}

static size_t encoding_filter_intermediate_to_internal(unsigned char **to, size_t *to_length, const unsigned char *from, size_t from_length)
{
	const zend_encoding *internal_encoding = zend_multibyte_get_internal_encoding();
	ZEND_ASSERT(internal_encoding);
	return zend_multibyte_encoding_converter(to, to_length, from, from_length,
internal_encoding, zend_multibyte_encoding_utf8);
}


static void _yy_push_state(int new_state)
{
	zend_stack_push(&SCNG(state_stack), (void *) &YYGETCONDITION());
	YYSETCONDITION(new_state);
}

#define yy_push_state(state_and_tsrm) _yy_push_state(yyc##state_and_tsrm)

static void yy_pop_state(void)
{
	int *stack_state = zend_stack_top(&SCNG(state_stack));
	YYSETCONDITION(*stack_state);
	zend_stack_del_top(&SCNG(state_stack));
}

static void yy_scan_buffer(char *str, size_t len)
{
	YYCURSOR       = (YYCTYPE*)str;
	YYLIMIT        = YYCURSOR + len;
	if (!SCNG(yy_start)) {
		SCNG(yy_start) = YYCURSOR;
	}
}

void startup_scanner(void)
{
	CG(parse_error) = 0;
	CG(doc_comment) = NULL;
	CG(extra_fn_flags) = 0;
	zend_stack_init(&SCNG(state_stack), sizeof(int));
	zend_stack_init(&SCNG(nest_location_stack), sizeof(zend_nest_location));
	zend_ptr_stack_init(&SCNG(heredoc_label_stack));
	SCNG(heredoc_scan_ahead) = 0;
}

static void heredoc_label_dtor(zend_heredoc_label *heredoc_label) {
    efree(heredoc_label->label);
}

void shutdown_scanner(void)
{
	CG(parse_error) = 0;
	RESET_DOC_COMMENT();
	zend_stack_destroy(&SCNG(state_stack));
	zend_stack_destroy(&SCNG(nest_location_stack));
	zend_ptr_stack_clean(&SCNG(heredoc_label_stack), (void (*)(void *)) &heredoc_label_dtor, 1);
	zend_ptr_stack_destroy(&SCNG(heredoc_label_stack));
	SCNG(heredoc_scan_ahead) = 0;
	SCNG(on_event) = NULL;
}

ZEND_API void zend_save_lexical_state(zend_lex_state *lex_state)
{
	lex_state->yy_leng   = SCNG(yy_leng);
	lex_state->yy_start  = SCNG(yy_start);
	lex_state->yy_text   = SCNG(yy_text);
	lex_state->yy_cursor = SCNG(yy_cursor);
	lex_state->yy_marker = SCNG(yy_marker);
	lex_state->yy_limit  = SCNG(yy_limit);

	lex_state->state_stack = SCNG(state_stack);
	zend_stack_init(&SCNG(state_stack), sizeof(int));

	lex_state->nest_location_stack = SCNG(nest_location_stack);
	zend_stack_init(&SCNG(nest_location_stack), sizeof(zend_nest_location));

	lex_state->heredoc_label_stack = SCNG(heredoc_label_stack);
	zend_ptr_stack_init(&SCNG(heredoc_label_stack));

	lex_state->in = SCNG(yy_in);
	lex_state->yy_state = YYSTATE;
	lex_state->filename = CG(compiled_filename);
	lex_state->lineno = CG(zend_lineno);
	CG(compiled_filename) = NULL;

	lex_state->script_org = SCNG(script_org);
	lex_state->script_org_size = SCNG(script_org_size);
	lex_state->script_filtered = SCNG(script_filtered);
	lex_state->script_filtered_size = SCNG(script_filtered_size);
	lex_state->input_filter = SCNG(input_filter);
	lex_state->output_filter = SCNG(output_filter);
	lex_state->script_encoding = SCNG(script_encoding);

	lex_state->on_event = SCNG(on_event);
	lex_state->on_event_context = SCNG(on_event_context);

	lex_state->ast = CG(ast);
	lex_state->ast_arena = CG(ast_arena);
}

ZEND_API void zend_restore_lexical_state(zend_lex_state *lex_state)
{
	SCNG(yy_leng)   = lex_state->yy_leng;
	SCNG(yy_start)  = lex_state->yy_start;
	SCNG(yy_text)   = lex_state->yy_text;
	SCNG(yy_cursor) = lex_state->yy_cursor;
	SCNG(yy_marker) = lex_state->yy_marker;
	SCNG(yy_limit)  = lex_state->yy_limit;

	zend_stack_destroy(&SCNG(state_stack));
	SCNG(state_stack) = lex_state->state_stack;

	zend_stack_destroy(&SCNG(nest_location_stack));
	SCNG(nest_location_stack) = lex_state->nest_location_stack;

	zend_ptr_stack_clean(&SCNG(heredoc_label_stack), (void (*)(void *)) &heredoc_label_dtor, 1);
	zend_ptr_stack_destroy(&SCNG(heredoc_label_stack));
	SCNG(heredoc_label_stack) = lex_state->heredoc_label_stack;

	SCNG(yy_in) = lex_state->in;
	YYSETCONDITION(lex_state->yy_state);
	CG(zend_lineno) = lex_state->lineno;
	zend_restore_compiled_filename(lex_state->filename);

	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
	SCNG(script_org) = lex_state->script_org;
	SCNG(script_org_size) = lex_state->script_org_size;
	SCNG(script_filtered) = lex_state->script_filtered;
	SCNG(script_filtered_size) = lex_state->script_filtered_size;
	SCNG(input_filter) = lex_state->input_filter;
	SCNG(output_filter) = lex_state->output_filter;
	SCNG(script_encoding) = lex_state->script_encoding;

	SCNG(on_event) = lex_state->on_event;
	SCNG(on_event_context) = lex_state->on_event_context;

	CG(ast) = lex_state->ast;
	CG(ast_arena) = lex_state->ast_arena;

	RESET_DOC_COMMENT();
}

ZEND_API zend_result zend_lex_tstring(zval *zv, unsigned char *ident)
{
	unsigned char *end = ident;
	while ((*end >= 'a' && *end <= 'z') || (*end >= 'A' && *end <= 'Z') || *end == '_') {
		end++;
	}

	size_t length = end - ident;
	if (length == 0) {
		ZEND_ASSERT(ident[0] == '<' && ident[1] == '?' && ident[2] == '=');
		zend_throw_exception(zend_ce_parse_error, "Cannot use \"<?=\" as an identifier", 0);
		return FAILURE;
	}

	if (SCNG(on_event)) {
		SCNG(on_event)(ON_FEEDBACK, T_STRING, 0, (char *) ident, length, SCNG(on_event_context));
	}

	ZVAL_STRINGL(zv, (char *) ident, length);
	return SUCCESS;
}

#define BOM_UTF32_BE	"\x00\x00\xfe\xff"
#define	BOM_UTF32_LE	"\xff\xfe\x00\x00"
#define	BOM_UTF16_BE	"\xfe\xff"
#define	BOM_UTF16_LE	"\xff\xfe"
#define	BOM_UTF8		"\xef\xbb\xbf"

static const zend_encoding *zend_multibyte_detect_utf_encoding(const unsigned char *script, size_t script_size)
{
	const unsigned char *p;
	int wchar_size = 2;
	int le = 0;

	/* utf-16 or utf-32? */
	p = script;
	assert(p >= script);
	while ((size_t)(p-script) < script_size) {
		p = memchr(p, 0, script_size-(p-script)-2);
		if (!p) {
			break;
		}
		if (*(p+1) == '\0' && *(p+2) == '\0') {
			wchar_size = 4;
			break;
		}

		/* searching for UTF-32 specific byte orders, so this will do */
		p += 4;
	}

	/* BE or LE? */
	p = script;
	assert(p >= script);
	while ((size_t)(p-script) < script_size) {
		if (*p == '\0' && *(p+wchar_size-1) != '\0') {
			/* BE */
			le = 0;
			break;
		} else if (*p != '\0' && *(p+wchar_size-1) == '\0') {
			/* LE* */
			le = 1;
			break;
		}
		p += wchar_size;
	}

	if (wchar_size == 2) {
		return le ? zend_multibyte_encoding_utf16le : zend_multibyte_encoding_utf16be;
	} else {
		return le ? zend_multibyte_encoding_utf32le : zend_multibyte_encoding_utf32be;
	}

	return NULL;
}

static const zend_encoding* zend_multibyte_detect_unicode(void)
{
	const zend_encoding *script_encoding = NULL;
	int bom_size;
	unsigned char *pos1, *pos2;

	if (LANG_SCNG(script_org_size) < sizeof(BOM_UTF32_LE)-1) {
		return NULL;
	}

	/* check out BOM */
	if (!memcmp(LANG_SCNG(script_org), BOM_UTF32_BE, sizeof(BOM_UTF32_BE)-1)) {
		script_encoding = zend_multibyte_encoding_utf32be;
		bom_size = sizeof(BOM_UTF32_BE)-1;
	} else if (!memcmp(LANG_SCNG(script_org), BOM_UTF32_LE, sizeof(BOM_UTF32_LE)-1)) {
		script_encoding = zend_multibyte_encoding_utf32le;
		bom_size = sizeof(BOM_UTF32_LE)-1;
	} else if (!memcmp(LANG_SCNG(script_org), BOM_UTF16_BE, sizeof(BOM_UTF16_BE)-1)) {
		script_encoding = zend_multibyte_encoding_utf16be;
		bom_size = sizeof(BOM_UTF16_BE)-1;
	} else if (!memcmp(LANG_SCNG(script_org), BOM_UTF16_LE, sizeof(BOM_UTF16_LE)-1)) {
		script_encoding = zend_multibyte_encoding_utf16le;
		bom_size = sizeof(BOM_UTF16_LE)-1;
	} else if (!memcmp(LANG_SCNG(script_org), BOM_UTF8, sizeof(BOM_UTF8)-1)) {
		script_encoding = zend_multibyte_encoding_utf8;
		bom_size = sizeof(BOM_UTF8)-1;
	}

	if (script_encoding) {
		/* remove BOM */
		LANG_SCNG(script_org) += bom_size;
		LANG_SCNG(script_org_size) -= bom_size;

		return script_encoding;
	}

	/* script contains NULL bytes -> auto-detection */
	if ((pos1 = memchr(LANG_SCNG(script_org), 0, LANG_SCNG(script_org_size)))) {
		/* check if the NULL byte is after the __HALT_COMPILER(); */
		pos2 = LANG_SCNG(script_org);

		while ((size_t)(pos1 - pos2) >= sizeof("__HALT_COMPILER();")-1) {
			pos2 = memchr(pos2, '_', pos1 - pos2);
			if (!pos2) break;
			pos2++;
			if (strncasecmp((char*)pos2, "_HALT_COMPILER", sizeof("_HALT_COMPILER")-1) == 0) {
				pos2 += sizeof("_HALT_COMPILER")-1;
				while (*pos2 == ' '  ||
					   *pos2 == '\t' ||
					   *pos2 == '\r' ||
					   *pos2 == '\n') {
					pos2++;
				}
				if (*pos2 == '(') {
					pos2++;
					while (*pos2 == ' '  ||
						   *pos2 == '\t' ||
						   *pos2 == '\r' ||
						   *pos2 == '\n') {
						pos2++;
					}
					if (*pos2 == ')') {
						pos2++;
						while (*pos2 == ' '  ||
							   *pos2 == '\t' ||
							   *pos2 == '\r' ||
							   *pos2 == '\n') {
							pos2++;
						}
						if (*pos2 == ';') {
							return NULL;
						}
					}
				}
			}
		}
		/* make best effort if BOM is missing */
		return zend_multibyte_detect_utf_encoding(LANG_SCNG(script_org), LANG_SCNG(script_org_size));
	}

	return NULL;
}

static const zend_encoding* zend_multibyte_find_script_encoding(void)
{
	const zend_encoding *script_encoding;

	if (CG(detect_unicode)) {
		/* check out bom(byte order mark) and see if containing wchars */
		script_encoding = zend_multibyte_detect_unicode();
		if (script_encoding != NULL) {
			/* bom or wchar detection is prior to 'script_encoding' option */
			return script_encoding;
		}
	}

	/* if no script_encoding specified, just leave alone */
	if (!CG(script_encoding_list) || !CG(script_encoding_list_size)) {
		return NULL;
	}

	/* if multiple encodings specified, detect automagically */
	if (CG(script_encoding_list_size) > 1) {
		return zend_multibyte_encoding_detector(LANG_SCNG(script_org), LANG_SCNG(script_org_size), CG(script_encoding_list), CG(script_encoding_list_size));
	}

	return CG(script_encoding_list)[0];
}

ZEND_API zend_result zend_multibyte_set_filter(const zend_encoding *onetime_encoding)
{
	const zend_encoding *internal_encoding = zend_multibyte_get_internal_encoding();
	const zend_encoding *script_encoding = onetime_encoding ? onetime_encoding: zend_multibyte_find_script_encoding();

	if (!script_encoding) {
		return FAILURE;
	}

	/* judge input/output filter */
	LANG_SCNG(script_encoding) = script_encoding;
	LANG_SCNG(input_filter) = NULL;
	LANG_SCNG(output_filter) = NULL;

	if (!internal_encoding || LANG_SCNG(script_encoding) == internal_encoding) {
		if (!zend_multibyte_check_lexer_compatibility(LANG_SCNG(script_encoding))) {
			/* and if not, work around w/ script_encoding -> utf-8 -> script_encoding conversion */
			LANG_SCNG(input_filter) = encoding_filter_script_to_intermediate;
			LANG_SCNG(output_filter) = encoding_filter_intermediate_to_script;
		} else {
			LANG_SCNG(input_filter) = NULL;
			LANG_SCNG(output_filter) = NULL;
		}
		return SUCCESS;
	}

	if (zend_multibyte_check_lexer_compatibility(internal_encoding)) {
		LANG_SCNG(input_filter) = encoding_filter_script_to_internal;
		LANG_SCNG(output_filter) = NULL;
	} else if (zend_multibyte_check_lexer_compatibility(LANG_SCNG(script_encoding))) {
		LANG_SCNG(input_filter) = NULL;
		LANG_SCNG(output_filter) = encoding_filter_script_to_internal;
	} else {
		/* both script and internal encodings are incompatible w/ flex */
		LANG_SCNG(input_filter) = encoding_filter_script_to_intermediate;
		LANG_SCNG(output_filter) = encoding_filter_intermediate_to_internal;
	}

	return SUCCESS;
}

ZEND_API zend_result open_file_for_scanning(zend_file_handle *file_handle)
{
	char *buf;
	size_t size;
	zend_string *compiled_filename;

	if (zend_stream_fixup(file_handle, &buf, &size) == FAILURE) {
		/* Still add it to open_files to make destroy_file_handle work */
		zend_llist_add_element(&CG(open_files), file_handle);
		file_handle->in_list = 1;
		return FAILURE;
	}

	ZEND_ASSERT(!EG(exception) && "stream_fixup() should have failed");
	zend_llist_add_element(&CG(open_files), file_handle);
	file_handle->in_list = 1;

	/* Reset the scanner for scanning the new file */
	SCNG(yy_in) = file_handle;
	SCNG(yy_start) = NULL;

	if (size != (size_t)-1) {
		if (CG(multibyte)) {
			SCNG(script_org) = (unsigned char*)buf;
			SCNG(script_org_size) = size;
			SCNG(script_filtered) = NULL;

			zend_multibyte_set_filter(NULL);

			if (SCNG(input_filter)) {
				if ((size_t)-1 == SCNG(input_filter)(&SCNG(script_filtered), &SCNG(script_filtered_size), SCNG(script_org), SCNG(script_org_size))) {
					zend_error_noreturn(E_COMPILE_ERROR, "Could not convert the script from the detected "
							"encoding \"%s\" to a compatible encoding", zend_multibyte_get_encoding_name(LANG_SCNG(script_encoding)));
				}
				buf = (char*)SCNG(script_filtered);
				size = SCNG(script_filtered_size);
			}
		}
		SCNG(yy_start) = (unsigned char *)buf;
		yy_scan_buffer(buf, size);
	} else {
		zend_error_noreturn(E_COMPILE_ERROR, "zend_stream_mmap() failed");
	}

	if (CG(skip_shebang)) {
		BEGIN(SHEBANG);
	} else {
		BEGIN(INITIAL);
	}

	if (file_handle->opened_path) {
		compiled_filename = zend_string_copy(file_handle->opened_path);
	} else {
		compiled_filename = zend_string_copy(file_handle->filename);
	}

	zend_set_compiled_filename(compiled_filename);
	zend_string_release_ex(compiled_filename, 0);

	RESET_DOC_COMMENT();
	CG(zend_lineno) = 1;
	CG(increment_lineno) = 0;
	return SUCCESS;
}

static zend_op_array *zend_compile(int type)
{
	zend_op_array *op_array = NULL;
	bool original_in_compilation = CG(in_compilation);

	CG(in_compilation) = 1;
	CG(ast) = NULL;
	CG(ast_arena) = zend_arena_create(1024 * 32);

	if (!zendparse()) {
		int last_lineno = CG(zend_lineno);
		zend_file_context original_file_context;
		zend_oparray_context original_oparray_context;
		zend_op_array *original_active_op_array = CG(active_op_array);

		op_array = emalloc(sizeof(zend_op_array));
		init_op_array(op_array, type, INITIAL_OP_ARRAY_SIZE);
		CG(active_op_array) = op_array;

		/* Use heap to not waste arena memory */
		op_array->fn_flags |= ZEND_ACC_HEAP_RT_CACHE;

		if (zend_ast_process) {
			zend_ast_process(CG(ast));
		}

		zend_file_context_begin(&original_file_context);
		zend_oparray_context_begin(&original_oparray_context);
		zend_compile_top_stmt(CG(ast));
		CG(zend_lineno) = last_lineno;
		zend_emit_final_return(type == ZEND_USER_FUNCTION);
		op_array->line_start = 1;
		op_array->line_end = last_lineno;
		pass_two(op_array);
		zend_oparray_context_end(&original_oparray_context);
		zend_file_context_end(&original_file_context);

		CG(active_op_array) = original_active_op_array;
	}

	zend_ast_destroy(CG(ast));
	zend_arena_destroy(CG(ast_arena));

	CG(in_compilation) = original_in_compilation;

	return op_array;
}

ZEND_API zend_op_array *compile_file(zend_file_handle *file_handle, int type)
{
	zend_lex_state original_lex_state;
	zend_op_array *op_array = NULL;
	zend_save_lexical_state(&original_lex_state);

	if (open_file_for_scanning(file_handle)==FAILURE) {
		if (!EG(exception)) {
			if (type==ZEND_REQUIRE) {
				zend_message_dispatcher(ZMSG_FAILED_REQUIRE_FOPEN, ZSTR_VAL(file_handle->filename));
			} else {
				zend_message_dispatcher(ZMSG_FAILED_INCLUDE_FOPEN, ZSTR_VAL(file_handle->filename));
			}
		}
	} else {
		op_array = zend_compile(ZEND_USER_FUNCTION);
	}

	zend_restore_lexical_state(&original_lex_state);
	return op_array;
}

ZEND_API zend_ast *zend_compile_string_to_ast(
		zend_string *code, zend_arena **ast_arena, zend_string *filename) {
	zval code_zv;
	bool original_in_compilation;
	zend_lex_state original_lex_state;
	zend_ast *ast;

	ZVAL_STR_COPY(&code_zv, code);

	original_in_compilation = CG(in_compilation);
	CG(in_compilation) = 1;

	zend_save_lexical_state(&original_lex_state);
	zend_prepare_string_for_scanning(&code_zv, filename);
	CG(ast) = NULL;
	CG(ast_arena) = zend_arena_create(1024 * 32);
	LANG_SCNG(yy_state) = yycINITIAL;

	if (zendparse() != 0) {
		zend_ast_destroy(CG(ast));
		zend_arena_destroy(CG(ast_arena));
		CG(ast) = NULL;
	}

	/* restore_lexical_state changes CG(ast) and CG(ast_arena) */
	ast = CG(ast);
	*ast_arena = CG(ast_arena);

	zend_restore_lexical_state(&original_lex_state);
	CG(in_compilation) = original_in_compilation;

	zval_ptr_dtor_str(&code_zv);

	return ast;
}

zend_op_array *compile_filename(int type, zend_string *filename)
{
	zend_file_handle file_handle;
	zend_op_array *retval;
	zend_string *opened_path = NULL;

	zend_stream_init_filename_ex(&file_handle, filename);

	retval = zend_compile_file(&file_handle, type);
	if (retval && file_handle.handle.stream.handle) {
		if (!file_handle.opened_path) {
			file_handle.opened_path = opened_path = zend_string_copy(filename);
		}

		zend_hash_add_empty_element(&EG(included_files), file_handle.opened_path);

		if (opened_path) {
			zend_string_release_ex(opened_path, 0);
		}
	}
	zend_destroy_file_handle(&file_handle);

	return retval;
}

ZEND_API void zend_prepare_string_for_scanning(zval *str, zend_string *filename)
{
	char *buf;
	size_t size, old_len;

	/* enforce ZEND_MMAP_AHEAD trailing NULLs for flex... */
	old_len = Z_STRLEN_P(str);
	Z_STR_P(str) = zend_string_extend(Z_STR_P(str), old_len + ZEND_MMAP_AHEAD, 0);
	Z_TYPE_INFO_P(str) = IS_STRING_EX;
	memset(Z_STRVAL_P(str) + old_len, 0, ZEND_MMAP_AHEAD + 1);

	SCNG(yy_in) = NULL;
	SCNG(yy_start) = NULL;

	buf = Z_STRVAL_P(str);
	size = old_len;

	if (CG(multibyte)) {
		SCNG(script_org) = (unsigned char*)buf;
		SCNG(script_org_size) = size;
		SCNG(script_filtered) = NULL;

		zend_multibyte_set_filter(zend_multibyte_get_internal_encoding());

		if (SCNG(input_filter)) {
			if ((size_t)-1 == SCNG(input_filter)(&SCNG(script_filtered), &SCNG(script_filtered_size), SCNG(script_org), SCNG(script_org_size))) {
				zend_error_noreturn(E_COMPILE_ERROR, "Could not convert the script from the detected "
						"encoding \"%s\" to a compatible encoding", zend_multibyte_get_encoding_name(LANG_SCNG(script_encoding)));
			}
			buf = (char*)SCNG(script_filtered);
			size = SCNG(script_filtered_size);
		}
	}

	yy_scan_buffer(buf, size);
	zend_set_compiled_filename(filename);
	CG(zend_lineno) = 1;
	CG(increment_lineno) = 0;
	RESET_DOC_COMMENT();
}


ZEND_API size_t zend_get_scanned_file_offset(void)
{
	size_t offset = SCNG(yy_cursor) - SCNG(yy_start);
	if (SCNG(input_filter)) {
		size_t original_offset = offset, length = 0;
		do {
			unsigned char *p = NULL;
			if ((size_t)-1 == SCNG(input_filter)(&p, &length, SCNG(script_org), offset)) {
				return (size_t)-1;
			}
			efree(p);
			if (length > original_offset) {
				offset--;
			} else if (length < original_offset) {
				offset++;
			}
		} while (original_offset != length);
	}
	return offset;
}

zend_op_array *compile_string(zend_string *source_string, const char *filename, zend_compile_position position)
{
	zend_lex_state original_lex_state;
	zend_op_array *op_array = NULL;
	zval tmp;
	zend_string *filename_str;

	if (ZSTR_LEN(source_string) == 0) {
		return NULL;
	}

	ZVAL_STR_COPY(&tmp, source_string);

	zend_save_lexical_state(&original_lex_state);
	filename_str = zend_string_init(filename, strlen(filename), 0);
	zend_prepare_string_for_scanning(&tmp, filename_str);
	zend_string_release(filename_str);

	switch (position) {
		case ZEND_COMPILE_POSITION_AT_SHEBANG:
			BEGIN(SHEBANG);
			break;
		case ZEND_COMPILE_POSITION_AT_OPEN_TAG:
			BEGIN(INITIAL);
			break;
		case ZEND_COMPILE_POSITION_AFTER_OPEN_TAG:
			BEGIN(ST_IN_SCRIPTING);
			break;
	}

	op_array = zend_compile(ZEND_EVAL_CODE);

	zend_restore_lexical_state(&original_lex_state);
	zval_ptr_dtor(&tmp);

	return op_array;
}


zend_result highlight_file(const char *filename, zend_syntax_highlighter_ini *syntax_highlighter_ini)
{
	zend_lex_state original_lex_state;
	zend_file_handle file_handle;

	zend_stream_init_filename(&file_handle, filename);
	zend_save_lexical_state(&original_lex_state);
	if (open_file_for_scanning(&file_handle)==FAILURE) {
		zend_message_dispatcher(ZMSG_FAILED_HIGHLIGHT_FOPEN, filename);
		zend_destroy_file_handle(&file_handle);
		zend_restore_lexical_state(&original_lex_state);
		return FAILURE;
	}
	zend_highlight(syntax_highlighter_ini);
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
	zend_destroy_file_handle(&file_handle);
	zend_restore_lexical_state(&original_lex_state);
	return SUCCESS;
}

void highlight_string(zend_string *str, zend_syntax_highlighter_ini *syntax_highlighter_ini, const char *filename)
{
	zend_lex_state original_lex_state;
	zval str_zv;
	zend_string *filename_str = zend_string_init(filename, strlen(filename), 0);
	ZVAL_STR_COPY(&str_zv, str);
	zend_save_lexical_state(&original_lex_state);
	zend_prepare_string_for_scanning(&str_zv, filename_str);
	zend_string_release(filename_str);
	BEGIN(INITIAL);
	zend_highlight(syntax_highlighter_ini);
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
	zend_restore_lexical_state(&original_lex_state);
	zval_ptr_dtor(&str_zv);
}

ZEND_API void zend_multibyte_yyinput_again(zend_encoding_filter old_input_filter, const zend_encoding *old_encoding)
{
	size_t length;
	unsigned char *new_yy_start;

	/* convert and set */
	if (!SCNG(input_filter)) {
		if (SCNG(script_filtered)) {
			efree(SCNG(script_filtered));
			SCNG(script_filtered) = NULL;
		}
		SCNG(script_filtered_size) = 0;
		length = SCNG(script_org_size);
		new_yy_start = SCNG(script_org);
	} else {
		if ((size_t)-1 == SCNG(input_filter)(&new_yy_start, &length, SCNG(script_org), SCNG(script_org_size))) {
			zend_error_noreturn(E_COMPILE_ERROR, "Could not convert the script from the detected "
					"encoding \"%s\" to a compatible encoding", zend_multibyte_get_encoding_name(LANG_SCNG(script_encoding)));
		}
		if (SCNG(script_filtered)) {
			efree(SCNG(script_filtered));
		}
		SCNG(script_filtered) = new_yy_start;
		SCNG(script_filtered_size) = length;
	}

	SCNG(yy_cursor) = new_yy_start + (SCNG(yy_cursor) - SCNG(yy_start));
	SCNG(yy_marker) = new_yy_start + (SCNG(yy_marker) - SCNG(yy_start));
	SCNG(yy_text) = new_yy_start + (SCNG(yy_text) - SCNG(yy_start));
	SCNG(yy_limit) = new_yy_start + length;

	SCNG(yy_start) = new_yy_start;
}


// TODO: avoid reallocation ???
# define zend_copy_value(zendlval, yytext, yyleng) \
	if (SCNG(output_filter)) { \
		size_t sz = 0; \
		char *s = NULL; \
		SCNG(output_filter)((unsigned char **)&s, &sz, (unsigned char *)yytext, (size_t)yyleng); \
		ZVAL_STRINGL(zendlval, s, sz); \
		efree(s); \
	} else if (yyleng == 1) { \
		ZVAL_INTERNED_STR(zendlval, ZSTR_CHAR((zend_uchar)*(yytext))); \
	} else { \
		ZVAL_STRINGL(zendlval, yytext, yyleng); \
	}

static zend_result zend_scan_escape_string(zval *zendlval, char *str, int len, char quote_type)
{
	char *s, *t;
	char *end;

	if (len <= 1) {
		if (len < 1) {
			ZVAL_EMPTY_STRING(zendlval);
		} else {
			zend_uchar c = (zend_uchar)*str;
			if (c == '\n' || c == '\r') {
				CG(zend_lineno)++;
			}
			ZVAL_INTERNED_STR(zendlval, ZSTR_CHAR(c));
		}
		goto skip_escape_conversion;
	}

	ZVAL_STRINGL(zendlval, str, len);

	/* convert escape sequences */
	s = Z_STRVAL_P(zendlval);
	end = s+Z_STRLEN_P(zendlval);
	while (1) {
		if (UNEXPECTED(*s=='\\')) {
			break;
		}
		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
		if (s == end) {
			goto skip_escape_conversion;
		}
	}

	t = s;
	while (s<end) {
		if (*s=='\\') {
			s++;
			if (s >= end) {
				*t++ = '\\';
				break;
			}

			switch(*s) {
				case 'n':
					*t++ = '\n';
					break;
				case 'r':
					*t++ = '\r';
					break;
				case 't':
					*t++ = '\t';
					break;
				case 'f':
					*t++ = '\f';
					break;
				case 'v':
					*t++ = '\v';
					break;
				case 'e':
#ifdef ZEND_WIN32
					*t++ = VK_ESCAPE;
#else
					*t++ = '\e';
#endif
					break;
				case '"':
				case '`':
					if (*s != quote_type) {
						*t++ = '\\';
						*t++ = *s;
						break;
					}
					ZEND_FALLTHROUGH;
				case '\\':
				case '$':
					*t++ = *s;
					break;
				case 'x':
				case 'X':
					if (ZEND_IS_HEX(*(s+1))) {
						char hex_buf[3] = { 0, 0, 0 };

						hex_buf[0] = *(++s);
						if (ZEND_IS_HEX(*(s+1))) {
							hex_buf[1] = *(++s);
						}
						*t++ = (char) ZEND_STRTOL(hex_buf, NULL, 16);
					} else {
						*t++ = '\\';
						*t++ = *s;
					}
					break;
				/* UTF-8 codepoint escape, format: /\\u\{\x+\}/ */
				case 'u':
					{
						/* cache where we started so we can parse after validating */
						char *start = s + 1;
						size_t len = 0;
						bool valid = 1;
						unsigned long codepoint;

						if (*start != '{') {
							/* we silently let this pass to avoid breaking code
							 * with JSON in string literals (e.g. "\"\u202e\""
							 */
							*t++ = '\\';
							*t++ = 'u';
							break;
						} else {
							/* on the other hand, invalid \u{blah} errors */
							s++;
							len++;
							s++;
							while (*s != '}') {
								if (!ZEND_IS_HEX(*s)) {
									valid = 0;
									break;
								} else {
									len++;
								}
								s++;
							}
							if (*s == '}') {
								valid = 1;
								len++;
							}
						}

						/* \u{} is invalid */
						if (len <= 2) {
							valid = 0;
						}

						if (!valid) {
							zend_throw_exception(zend_ce_parse_error,
								"Invalid UTF-8 codepoint escape sequence", 0);
							zval_ptr_dtor(zendlval);
							ZVAL_UNDEF(zendlval);
							return FAILURE;
						}

						errno = 0;
						codepoint = strtoul(start + 1, NULL, 16);

						/* per RFC 3629, UTF-8 can only represent 21 bits */
						if (codepoint > 0x10FFFF || errno) {
							zend_throw_exception(zend_ce_parse_error,
								"Invalid UTF-8 codepoint escape sequence: Codepoint too large", 0);
							zval_ptr_dtor(zendlval);
							ZVAL_UNDEF(zendlval);
							return FAILURE;
						}

						/* based on https://en.wikipedia.org/wiki/UTF-8#Sample_code */
						if (codepoint < 0x80) {
							*t++ = codepoint;
						} else if (codepoint <= 0x7FF) {
							*t++ = (codepoint >> 6) + 0xC0;
							*t++ = (codepoint & 0x3F) + 0x80;
						} else if (codepoint <= 0xFFFF) {
							*t++ = (codepoint >> 12) + 0xE0;
							*t++ = ((codepoint >> 6) & 0x3F) + 0x80;
							*t++ = (codepoint & 0x3F) + 0x80;
						} else if (codepoint <= 0x10FFFF) {
							*t++ = (codepoint >> 18) + 0xF0;
							*t++ = ((codepoint >> 12) & 0x3F) + 0x80;
							*t++ = ((codepoint >> 6) & 0x3F) + 0x80;
							*t++ = (codepoint & 0x3F) + 0x80;
						}
					}
					break;
				default:
					/* check for an octal */
					if (ZEND_IS_OCT(*s)) {
						char octal_buf[4] = { 0, 0, 0, 0 };

						octal_buf[0] = *s;
						if (ZEND_IS_OCT(*(s+1))) {
							octal_buf[1] = *(++s);
							if (ZEND_IS_OCT(*(s+1))) {
								octal_buf[2] = *(++s);
							}
						}
						if (octal_buf[2] && (octal_buf[0] > '3') && !SCNG(heredoc_scan_ahead)) {
							/* 3 octit values must not overflow 0xFF (\377) */
							zend_error(E_COMPILE_WARNING, "Octal escape sequence overflow \\%s is greater than \\377", octal_buf);
						}

						*t++ = (char) ZEND_STRTOL(octal_buf, NULL, 8);
					} else {
						*t++ = '\\';
						*t++ = *s;
					}
					break;
			}
		} else {
			*t++ = *s;
		}

		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
	}
	*t = 0;
	Z_STRLEN_P(zendlval) = t - Z_STRVAL_P(zendlval);

skip_escape_conversion:
	if (SCNG(output_filter)) {
		size_t sz = 0;
		unsigned char *str;
		// TODO: avoid realocation ???
		s = Z_STRVAL_P(zendlval);
		SCNG(output_filter)(&str, &sz, (unsigned char *)s, (size_t)Z_STRLEN_P(zendlval));
		zval_ptr_dtor(zendlval);
		ZVAL_STRINGL(zendlval, (char *) str, sz);
		efree(str);
	}
	return SUCCESS;
}

#define HEREDOC_USING_SPACES 1
#define HEREDOC_USING_TABS 2

static const char *next_newline(const char *str, const char *end, size_t *newline_len) {
	for (; str < end; str++) {
		if (*str == '\r') {
			*newline_len = str + 1 < end && *(str + 1) == '\n' ? 2 : 1;
			return str;
		} else if (*str == '\n') {
			*newline_len = 1;
			return str;
		}
	}
	*newline_len = 0;
	return NULL;
}

static bool strip_multiline_string_indentation(
	zval *zendlval, int indentation, bool using_spaces,
	bool newline_at_start, bool newline_at_end)
{
	const char *str = Z_STRVAL_P(zendlval), *end = str + Z_STRLEN_P(zendlval);
	char *copy = Z_STRVAL_P(zendlval);

	int newline_count = 0;
	size_t newline_len;
	const char *nl;

	if (!newline_at_start) {
		nl = next_newline(str, end, &newline_len);
		if (!nl) {
			return 1;
		}

		str = nl + newline_len;
		copy = (char *) nl + newline_len;
		newline_count++;
	} else {
		nl = str;
	}

	/* <= intentional */
	while (str <= end && nl) {
		size_t skip;
		nl = next_newline(str, end, &newline_len);
		if (!nl && newline_at_end) {
			nl = end;
		}

		/* Try to skip indentation */
		for (skip = 0; skip < indentation; skip++, str++) {
			if (str == nl) {
				/* Don't require full indentation on whitespace-only lines */
				break;
			}

			if (str == end || (*str != ' ' && *str != '\t')) {
				CG(zend_lineno) += newline_count;
				zend_throw_exception_ex(zend_ce_parse_error, 0,
					"Invalid body indentation level (expecting an indentation level of at least %d)", indentation);
				goto error;
			}

			if ((!using_spaces && *str == ' ') || (using_spaces && *str == '\t')) {
				CG(zend_lineno) += newline_count;
				zend_throw_exception(zend_ce_parse_error,
					"Invalid indentation - tabs and spaces cannot be mixed", 0);
				goto error;
			}
		}

		if (str == end) {
			break;
		}

		size_t len = nl ? (nl - str + newline_len) : (end - str);
		memmove(copy, str, len);
		str += len;
		copy += len;
		newline_count++;
	}

	*copy = '\0';
	Z_STRLEN_P(zendlval) = copy - Z_STRVAL_P(zendlval);
	return 1;

error:
	zval_ptr_dtor_str(zendlval);
	ZVAL_UNDEF(zendlval);

	return 0;
}

static void copy_heredoc_label_stack(void *void_heredoc_label)
{
	zend_heredoc_label *heredoc_label = void_heredoc_label;
	zend_heredoc_label *new_heredoc_label = emalloc(sizeof(zend_heredoc_label));

	*new_heredoc_label = *heredoc_label;
	new_heredoc_label->label = estrndup(heredoc_label->label, heredoc_label->length);

	zend_ptr_stack_push(&SCNG(heredoc_label_stack), (void *) new_heredoc_label);
}

/* Check that { }, [ ], ( ) are nested correctly */
static void report_bad_nesting(char opening, int opening_lineno, char closing)
{
	char   buf[256];
	size_t used = 0;

	used = snprintf(buf, sizeof(buf), "Unclosed '%c'", opening);

	if (opening_lineno != CG(zend_lineno)) {
		used += snprintf(buf + used, sizeof(buf) - used, " on line %d", opening_lineno);
	}

	if (closing) { 	/* 'closing' will be 0 if at end of file */
		used += snprintf(buf + used, sizeof(buf) - used, " does not match '%c'", closing);
	}

	zend_throw_exception(zend_ce_parse_error, buf, 0);
}

static void enter_nesting(char opening)
{
	zend_nest_location nest_loc = {opening, CG(zend_lineno)};
	zend_stack_push(&SCNG(nest_location_stack), &nest_loc);
}

static zend_result exit_nesting(char closing)
{
	if (zend_stack_is_empty(&SCNG(nest_location_stack))) {
		zend_throw_exception_ex(zend_ce_parse_error, 0, "Unmatched '%c'", closing);
		return FAILURE;
	}

	zend_nest_location *nest_loc = zend_stack_top(&SCNG(nest_location_stack));
	char opening = nest_loc->text;

	if ((opening == '{' && closing != '}') ||
	    (opening == '[' && closing != ']') ||
	    (opening == '(' && closing != ')')) {
		report_bad_nesting(opening, nest_loc->lineno, closing);
		return FAILURE;
	}

	zend_stack_del_top(&SCNG(nest_location_stack));
	return SUCCESS;
}

static zend_result check_nesting_at_end(void)
{
	if (!zend_stack_is_empty(&SCNG(nest_location_stack))) {
		zend_nest_location *nest_loc = zend_stack_top(&SCNG(nest_location_stack));
		report_bad_nesting(nest_loc->text, nest_loc->lineno, 0);
		return FAILURE;
	}

	return SUCCESS;
}

#define PARSER_MODE() \
	EXPECTED(elem != NULL)

#define RETURN_TOKEN(_token) do { \
		token = _token; \
		goto emit_token; \
	} while (0)

#define RETURN_TOKEN_WITH_VAL(_token) do { \
		token = _token; \
		goto emit_token_with_val; \
	} while (0)

#define RETURN_TOKEN_WITH_STR(_token, _offset) do { \
		token = _token; \
		offset = _offset; \
		goto emit_token_with_str; \
	} while (0)

#define RETURN_TOKEN_WITH_IDENT(_token) do { \
		token = _token; \
		goto emit_token_with_ident; \
	} while (0)

#define RETURN_OR_SKIP_TOKEN(_token) do { \
		token = _token; \
		if (PARSER_MODE()) { \
			goto skip_token; \
		} \
		goto emit_token; \
	} while (0)

#define RETURN_EXIT_NESTING_TOKEN(_token) do { \
		if (exit_nesting(_token) && PARSER_MODE()) { \
			RETURN_TOKEN(T_ERROR); \
		} else { \
			RETURN_TOKEN(_token); \
		} \
	} while(0)

#define RETURN_END_TOKEN do { \
		if (check_nesting_at_end() && PARSER_MODE()) { \
			RETURN_TOKEN(T_ERROR); \
		} else { \
			RETURN_TOKEN(END); \
		} \
	} while (0)

int ZEND_FASTCALL lex_scan(zval *zendlval, zend_parser_stack_elem *elem)
{
int token;
int offset;
int start_line = CG(zend_lineno);

	ZVAL_UNDEF(zendlval);
restart:
	SCNG(yy_text) = YYCURSOR;


{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	if (YYGETCONDITION() < 5) {
		if (YYGETCONDITION() < 2) {
			if (YYGETCONDITION() < 1) {
				goto yyc_ST_IN_SCRIPTING;
			} else {
				goto yyc_ST_LOOKING_FOR_PROPERTY;
			}
		} else {
			if (YYGETCONDITION() < 3) {
				goto yyc_ST_BACKQUOTE;
			} else {
				if (YYGETCONDITION() < 4) {
					goto yyc_ST_DOUBLE_QUOTES;
				} else {
					goto yyc_ST_HEREDOC;
				}
			}
		}
	} else {
		if (YYGETCONDITION() < 8) {
			if (YYGETCONDITION() < 6) {
				goto yyc_ST_LOOKING_FOR_VARNAME;
			} else {
				if (YYGETCONDITION() < 7) {
					goto yyc_ST_VAR_OFFSET;
				} else {
					goto yyc_SHEBANG;
				}
			}
		} else {
			if (YYGETCONDITION() < 9) {
				goto yyc_INITIAL;
			} else {
				if (YYGETCONDITION() < 10) {
					goto yyc_ST_END_HEREDOC;
				} else {
					goto yyc_ST_NOWDOC;
				}
			}
		}
	}
/* *********************************** */
yyc_INITIAL:
	YYDEBUG(1, *YYCURSOR);
	YYFILL(7);
	yych = *YYCURSOR;
	if (yych != '<') goto yy5;
	YYDEBUG(3, *YYCURSOR);
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '?') goto yy6;
yy4:
	YYDEBUG(4, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
	{
	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}

inline_char_handler:

	while (1) {
		YYCTYPE *ptr = memchr(YYCURSOR, '<', YYLIMIT - YYCURSOR);

		YYCURSOR = ptr ? ptr + 1 : YYLIMIT;

		if (YYCURSOR >= YYLIMIT) {
			break;
		}

		if (*YYCURSOR == '?') {
			if (CG(short_tags) /* <? */
				|| (*(YYCURSOR + 1) == '=') /* <?= */
				|| (!strncasecmp((char*)YYCURSOR + 1, "php", 3) && /* <?php[ \t\r\n] */
					(YYCURSOR + 4 == YYLIMIT ||
					YYCURSOR[4] == ' ' || YYCURSOR[4] == '\t' ||
					YYCURSOR[4] == '\n' || YYCURSOR[4] == '\r'))
			) {
				YYCURSOR--;
				break;
			}
		}
	}

	yyleng = YYCURSOR - SCNG(yy_text);

	if (SCNG(output_filter)) {
		size_t readsize;
		char *s = NULL;
		size_t sz = 0;
		// TODO: avoid reallocation ???
		readsize = SCNG(output_filter)((unsigned char **)&s, &sz, (unsigned char *)yytext, (size_t)yyleng);
		ZVAL_STRINGL(zendlval, s, sz);
		efree(s);
		if (readsize < yyleng) {
			yyless(readsize);
		}
	} else if (yyleng == 1) {
		ZVAL_INTERNED_STR(zendlval, ZSTR_CHAR((zend_uchar)*yytext));
	} else {
		ZVAL_STRINGL(zendlval, yytext, yyleng);
	}
	HANDLE_NEWLINES(yytext, yyleng);
	RETURN_TOKEN_WITH_VAL(T_INLINE_HTML);
}
yy5:
	YYDEBUG(5, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy4;
yy6:
	YYDEBUG(6, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 'O') {
		if (yych == '=') goto yy8;
	} else {
		if (yych <= 'P') goto yy10;
		if (yych == 'p') goto yy10;
	}
yy7:
	YYDEBUG(7, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
	{
	if (CG(short_tags)) {
		BEGIN(ST_IN_SCRIPTING);
		RETURN_OR_SKIP_TOKEN(T_OPEN_TAG);
	} else {
		goto inline_char_handler;
	}
}
yy8:
	YYDEBUG(8, *YYCURSOR);
	++YYCURSOR;
	YYDEBUG(9, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
	{
	BEGIN(ST_IN_SCRIPTING);
	if (PARSER_MODE()) {
		/* We'll reject this as an identifier in zend_lex_tstring. */
		RETURN_TOKEN_WITH_IDENT(T_ECHO);
	}
	RETURN_TOKEN(T_OPEN_TAG_WITH_ECHO);
}
yy10:
	YYDEBUG(10, *YYCURSOR);
	yych = *++YYCURSOR;
	if (yych == 'H') goto yy12;
	if (yych == 'h') goto yy12;
yy11:
	YYDEBUG(11, *YYCURSOR);
	YYCURSOR = YYMARKER;
	goto yy7;
yy12:
	YYDEBUG(12, *YYCURSOR);
	yych = *++YYCURSOR;
	if (yych == 'P') goto yy13;
	if (yych != 'p') goto yy11;
yy13:
	YYDEBUG(13, *YYCURSOR);
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= '\f') {
		if (yych <= 0x08) goto yy14;
		if (yych <= '\n') goto yy15;
	} else {
		if (yych <= '\r') goto yy17;
		if (yych == ' ') goto yy15;
	}
yy14:
	YYDEBUG(14, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
	{
	/* Allow <?php followed by end of file. */
	if (YYCURSOR == YYLIMIT) {
		BEGIN(ST_IN_SCRIPTING);
		RETURN_OR_SKIP_TOKEN(T_OPEN_TAG);
	}
	/* Degenerate case: <?phpX is interpreted as <? phpX with short tags. */
	if (CG(short_tags)) {
		yyless(2);
		BEGIN(ST_IN_SCRIPTING);
		RETURN_OR_SKIP_TOKEN(T_OPEN_TAG);
	}
	goto inline_char_handler;
}
yy15:
	YYDEBUG(15, *YYCURSOR);
	++YYCURSOR;
yy16:
	YYDEBUG(16, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
	{
	HANDLE_NEWLINE(yytext[yyleng-1]);
	BEGIN(ST_IN_SCRIPTING);
	RETURN_OR_SKIP_TOKEN(T_OPEN_TAG);
}
yy17:
	YYDEBUG(17, *YYCURSOR);
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '\n') goto yy15;
	goto yy16;
/* *********************************** */
yyc_SHEBANG:
	{
		static const unsigned char yybm[] = {
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,   0,  64,  64, 128,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
		};
		YYDEBUG(18, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych != '#') goto yy22;
		YYDEBUG(20, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '!') goto yy23;
yy21:
		YYDEBUG(21, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(0);
	BEGIN(INITIAL);
	goto restart;
}
yy22:
		YYDEBUG(22, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy21;
yy23:
		YYDEBUG(23, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(24, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy23;
		}
		if (yych <= '\n') goto yy28;
yy25:
		YYDEBUG(25, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(26, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy23;
		}
		if (yych <= '\n') goto yy28;
		goto yy25;
yy27:
		YYDEBUG(27, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	CG(zend_lineno)++;
	BEGIN(INITIAL);
	goto restart;
}
yy28:
		YYDEBUG(28, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy27;
	}
/* *********************************** */
yyc_ST_BACKQUOTE:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(29, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych != '$') goto yy36;
		} else {
			if (yych <= '`') goto yy34;
			if (yych == '{') goto yy33;
			goto yy36;
		}
		YYDEBUG(31, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '_') {
			if (yych <= '@') goto yy32;
			if (yych <= 'Z') goto yy39;
			if (yych >= '_') goto yy39;
		} else {
			if (yych <= 'z') {
				if (yych >= 'a') goto yy39;
			} else {
				if (yych <= '{') goto yy42;
				if (yych >= 0x80) goto yy39;
			}
		}
yy32:
		YYDEBUG(32, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}
	if (yytext[0] == '\\' && YYCURSOR < YYLIMIT) {
		YYCURSOR++;
	}

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '`':
				break;
			case '$':
				if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
					break;
				}
				continue;
			case '{':
				if (*YYCURSOR == '$') {
					break;
				}
				continue;
			case '\\':
				if (YYCURSOR < YYLIMIT) {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}

		YYCURSOR--;
		break;
	}

	yyleng = YYCURSOR - SCNG(yy_text);

	if (EXPECTED(zend_scan_escape_string(zendlval, yytext, yyleng, '`') == SUCCESS)
	 || !PARSER_MODE()) {
		RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
	} else {
		RETURN_TOKEN(T_ERROR);
	}
}
yy33:
		YYDEBUG(33, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '$') goto yy37;
		goto yy32;
yy34:
		YYDEBUG(34, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(35, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	BEGIN(ST_IN_SCRIPTING);
	RETURN_TOKEN('`');
}
yy36:
		YYDEBUG(36, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy32;
yy37:
		YYDEBUG(37, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(38, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_IN_SCRIPTING);
	yyless(1);
	enter_nesting('{');
	RETURN_TOKEN(T_CURLY_OPEN);
}
yy39:
		YYDEBUG(39, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(4);
		yych = *YYCURSOR;
		YYDEBUG(40, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy39;
		}
		if (yych <= '>') {
			if (yych == '-') goto yy44;
		} else {
			if (yych <= '?') goto yy46;
			if (yych <= '@') goto yy41;
			if (yych <= '[') goto yy47;
		}
yy41:
		YYDEBUG(41, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy42:
		YYDEBUG(42, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(43, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME);
	enter_nesting('{');
	RETURN_TOKEN(T_DOLLAR_OPEN_CURLY_BRACES);
}
yy44:
		YYDEBUG(44, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy53;
yy45:
		YYDEBUG(45, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy41;
yy46:
		YYDEBUG(46, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '-') goto yy49;
		goto yy45;
yy47:
		YYDEBUG(47, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(48, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy49:
		YYDEBUG(49, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '>') goto yy45;
		YYDEBUG(50, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy45;
			if (yych <= 'Z') goto yy51;
			if (yych <= '^') goto yy45;
		} else {
			if (yych <= '`') goto yy45;
			if (yych <= 'z') goto yy51;
			if (yych <= 0x7F) goto yy45;
		}
yy51:
		YYDEBUG(51, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(52, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 4);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy53:
		YYDEBUG(53, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy45;
			if (yych <= 'Z') goto yy54;
			if (yych <= '^') goto yy45;
		} else {
			if (yych <= '`') goto yy45;
			if (yych <= 'z') goto yy54;
			if (yych <= 0x7F) goto yy45;
		}
yy54:
		YYDEBUG(54, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(55, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
	}
/* *********************************** */
yyc_ST_DOUBLE_QUOTES:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(56, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '#') {
			if (yych == '"') goto yy61;
			goto yy63;
		} else {
			if (yych <= '$') goto yy58;
			if (yych == '{') goto yy60;
			goto yy63;
		}
yy58:
		YYDEBUG(58, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '_') {
			if (yych <= '@') goto yy59;
			if (yych <= 'Z') goto yy66;
			if (yych >= '_') goto yy66;
		} else {
			if (yych <= 'z') {
				if (yych >= 'a') goto yy66;
			} else {
				if (yych <= '{') goto yy69;
				if (yych >= 0x80) goto yy66;
			}
		}
yy59:
		YYDEBUG(59, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	if (GET_DOUBLE_QUOTES_SCANNED_LENGTH()) {
		YYCURSOR += GET_DOUBLE_QUOTES_SCANNED_LENGTH() - 1;
		SET_DOUBLE_QUOTES_SCANNED_LENGTH(0);

		goto double_quotes_scan_done;
	}

	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}
	if (yytext[0] == '\\' && YYCURSOR < YYLIMIT) {
		YYCURSOR++;
	}

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '"':
				break;
			case '$':
				if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
					break;
				}
				continue;
			case '{':
				if (*YYCURSOR == '$') {
					break;
				}
				continue;
			case '\\':
				if (YYCURSOR < YYLIMIT) {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}

		YYCURSOR--;
		break;
	}

double_quotes_scan_done:
	yyleng = YYCURSOR - SCNG(yy_text);

	if (EXPECTED(zend_scan_escape_string(zendlval, yytext, yyleng, '"') == SUCCESS)
	 || !PARSER_MODE()) {
		RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
	} else {
		RETURN_TOKEN(T_ERROR);
	}
}
yy60:
		YYDEBUG(60, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '$') goto yy64;
		goto yy59;
yy61:
		YYDEBUG(61, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(62, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	BEGIN(ST_IN_SCRIPTING);
	RETURN_TOKEN('"');
}
yy63:
		YYDEBUG(63, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy59;
yy64:
		YYDEBUG(64, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(65, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_IN_SCRIPTING);
	yyless(1);
	enter_nesting('{');
	RETURN_TOKEN(T_CURLY_OPEN);
}
yy66:
		YYDEBUG(66, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(4);
		yych = *YYCURSOR;
		YYDEBUG(67, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy66;
		}
		if (yych <= '>') {
			if (yych == '-') goto yy71;
		} else {
			if (yych <= '?') goto yy73;
			if (yych <= '@') goto yy68;
			if (yych <= '[') goto yy74;
		}
yy68:
		YYDEBUG(68, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy69:
		YYDEBUG(69, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(70, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME);
	enter_nesting('{');
	RETURN_TOKEN(T_DOLLAR_OPEN_CURLY_BRACES);
}
yy71:
		YYDEBUG(71, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy80;
yy72:
		YYDEBUG(72, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy68;
yy73:
		YYDEBUG(73, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '-') goto yy76;
		goto yy72;
yy74:
		YYDEBUG(74, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(75, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy76:
		YYDEBUG(76, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '>') goto yy72;
		YYDEBUG(77, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy72;
			if (yych <= 'Z') goto yy78;
			if (yych <= '^') goto yy72;
		} else {
			if (yych <= '`') goto yy72;
			if (yych <= 'z') goto yy78;
			if (yych <= 0x7F) goto yy72;
		}
yy78:
		YYDEBUG(78, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(79, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 4);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy80:
		YYDEBUG(80, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy72;
			if (yych <= 'Z') goto yy81;
			if (yych <= '^') goto yy72;
		} else {
			if (yych <= '`') goto yy72;
			if (yych <= 'z') goto yy81;
			if (yych <= 0x7F) goto yy72;
		}
yy81:
		YYDEBUG(81, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(82, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
	}
/* *********************************** */
yyc_ST_END_HEREDOC:
	YYDEBUG(83, *YYCURSOR);
	YYFILL(1);
	yych = *YYCURSOR;
	YYDEBUG(85, *YYCURSOR);
	++YYCURSOR;
	YYDEBUG(86, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
	{
	zend_heredoc_label *heredoc_label = zend_ptr_stack_pop(&SCNG(heredoc_label_stack));

	yyleng = heredoc_label->indentation + heredoc_label->length;
	YYCURSOR += yyleng - 1;

	heredoc_label_dtor(heredoc_label);
	efree(heredoc_label);

	BEGIN(ST_IN_SCRIPTING);
	RETURN_TOKEN(T_END_HEREDOC);
}
/* *********************************** */
yyc_ST_HEREDOC:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(87, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych == '$') goto yy89;
		if (yych == '{') goto yy91;
		goto yy92;
yy89:
		YYDEBUG(89, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '_') {
			if (yych <= '@') goto yy90;
			if (yych <= 'Z') goto yy95;
			if (yych >= '_') goto yy95;
		} else {
			if (yych <= 'z') {
				if (yych >= 'a') goto yy95;
			} else {
				if (yych <= '{') goto yy98;
				if (yych >= 0x80) goto yy95;
			}
		}
yy90:
		YYDEBUG(90, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	zend_heredoc_label *heredoc_label = zend_ptr_stack_top(&SCNG(heredoc_label_stack));
	int newline = 0, indentation = 0, spacing = 0;

	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}

	YYCURSOR--;

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '\r':
				if (*YYCURSOR == '\n') {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			case '\n':
				indentation = spacing = 0;

				while (YYCURSOR < YYLIMIT && (*YYCURSOR == ' ' || *YYCURSOR == '\t')) {
					if (*YYCURSOR == '\t') {
						spacing |= HEREDOC_USING_TABS;
					} else {
						spacing |= HEREDOC_USING_SPACES;
					}
					++YYCURSOR;
					++indentation;
				}

				if (YYCURSOR == YYLIMIT) {
					yyleng = YYCURSOR - SCNG(yy_text);
					HANDLE_NEWLINES(yytext, yyleng);
					ZVAL_NULL(zendlval);
					RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
				}

				/* Check for ending label on the next line */
				if (IS_LABEL_START(*YYCURSOR) && heredoc_label->length < YYLIMIT - YYCURSOR && !memcmp(YYCURSOR, heredoc_label->label, heredoc_label->length)) {
					if (IS_LABEL_SUCCESSOR(YYCURSOR[heredoc_label->length])) {
						continue;
					}

					if (spacing == (HEREDOC_USING_SPACES | HEREDOC_USING_TABS)) {
						zend_throw_exception(zend_ce_parse_error, "Invalid indentation - tabs and spaces cannot be mixed", 0);
						if (PARSER_MODE()) {
							RETURN_TOKEN(T_ERROR);
						}
					}

					/* newline before label will be subtracted from returned text, but
					 * yyleng/yytext will include it, for zend_highlight/strip, tokenizer, etc. */
					if (YYCURSOR[-indentation - 2] == '\r' && YYCURSOR[-indentation - 1] == '\n') {
						newline = 2; /* Windows newline */
					} else {
						newline = 1;
					}

					CG(increment_lineno) = 1; /* For newline before label */

					if (SCNG(heredoc_scan_ahead)) {
						SCNG(heredoc_indentation) = indentation;
						SCNG(heredoc_indentation_uses_spaces) = (spacing == HEREDOC_USING_SPACES);
					} else {
						YYCURSOR -= indentation;
					}

					BEGIN(ST_END_HEREDOC);

					goto heredoc_scan_done;
				}
				continue;
			case '$':
				if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
					break;
				}
				continue;
			case '{':
				if (*YYCURSOR == '$') {
					break;
				}
				continue;
			case '\\':
				if (YYCURSOR < YYLIMIT && *YYCURSOR != '\n' && *YYCURSOR != '\r') {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}

		YYCURSOR--;
		break;
	}

heredoc_scan_done:

	yyleng = YYCURSOR - SCNG(yy_text);
	ZVAL_STRINGL(zendlval, yytext, yyleng - newline);

	if (!SCNG(heredoc_scan_ahead) && !EG(exception) && PARSER_MODE()) {
		bool newline_at_start = *(yytext - 1) == '\n' || *(yytext - 1) == '\r';
		zend_string *copy = Z_STR_P(zendlval);

		if (!strip_multiline_string_indentation(
				zendlval, heredoc_label->indentation, heredoc_label->indentation_uses_spaces,
				newline_at_start, newline != 0)) {
			RETURN_TOKEN(T_ERROR);
		}

		if (UNEXPECTED(zend_scan_escape_string(zendlval, ZSTR_VAL(copy), ZSTR_LEN(copy), 0) != SUCCESS)) {
			zend_string_efree(copy);
			RETURN_TOKEN(T_ERROR);
		}

		zend_string_efree(copy);
	} else {
		HANDLE_NEWLINES(yytext, yyleng - newline);
	}

	RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
}
yy91:
		YYDEBUG(91, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '$') goto yy93;
		goto yy90;
yy92:
		YYDEBUG(92, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy90;
yy93:
		YYDEBUG(93, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(94, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_IN_SCRIPTING);
	yyless(1);
	enter_nesting('{');
	RETURN_TOKEN(T_CURLY_OPEN);
}
yy95:
		YYDEBUG(95, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(4);
		yych = *YYCURSOR;
		YYDEBUG(96, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy95;
		}
		if (yych <= '>') {
			if (yych == '-') goto yy100;
		} else {
			if (yych <= '?') goto yy102;
			if (yych <= '@') goto yy97;
			if (yych <= '[') goto yy103;
		}
yy97:
		YYDEBUG(97, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy98:
		YYDEBUG(98, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(99, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME);
	enter_nesting('{');
	RETURN_TOKEN(T_DOLLAR_OPEN_CURLY_BRACES);
}
yy100:
		YYDEBUG(100, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy109;
yy101:
		YYDEBUG(101, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy97;
yy102:
		YYDEBUG(102, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '-') goto yy105;
		goto yy101;
yy103:
		YYDEBUG(103, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(104, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy105:
		YYDEBUG(105, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '>') goto yy101;
		YYDEBUG(106, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy101;
			if (yych <= 'Z') goto yy107;
			if (yych <= '^') goto yy101;
		} else {
			if (yych <= '`') goto yy101;
			if (yych <= 'z') goto yy107;
			if (yych <= 0x7F) goto yy101;
		}
yy107:
		YYDEBUG(107, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(108, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 4);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy109:
		YYDEBUG(109, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy101;
			if (yych <= 'Z') goto yy110;
			if (yych <= '^') goto yy101;
		} else {
			if (yych <= '`') goto yy101;
			if (yych <= 'z') goto yy110;
			if (yych <= 0x7F) goto yy101;
		}
yy110:
		YYDEBUG(110, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(111, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
	}
/* *********************************** */
yyc_ST_IN_SCRIPTING:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0, 192,  64,   0,   0,  64,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			192,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			 62,  62,  54,  54,  54,  54,  54,  54, 
			 38,  38,   0,   0,   0,   0,   0,   0, 
			  0,  34,  34,  34,  34,  34,  34,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   0,   0,   0,   0,   2, 
			  0,  34,  34,  34,  34,  34,  34,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   0,   0,   0,   0,   0, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
		};
		YYDEBUG(112, *YYCURSOR);
		YYFILL(16);
		yych = *YYCURSOR;
		YYDEBUG(-1, yych);
		switch (yych) {
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\v':
		case '\f':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x1F:
		case 0x7F:	goto yy181;
		case '\t':
		case '\n':
		case '\r':
		case ' ':	goto yy135;
		case '!':	goto yy148;
		case '"':	goto yy177;
		case '#':	goto yy120;
		case '$':	goto yy163;
		case '%':	goto yy153;
		case '&':	goto yy154;
		case '\'':	goto yy175;
		case '(':	goto yy141;
		case ')':
		case ']':	goto yy160;
		case '*':	goto yy151;
		case '+':	goto yy147;
		case ',':
		case ';':
		case '@':
		case '~':	goto yy164;
		case '-':	goto yy132;
		case '.':	goto yy138;
		case '/':	goto yy152;
		case '0':	goto yy169;
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':	goto yy171;
		case ':':	goto yy137;
		case '<':	goto yy149;
		case '=':	goto yy145;
		case '>':	goto yy150;
		case '?':	goto yy134;
		case 'A':
		case 'a':	goto yy126;
		case 'B':
		case 'b':	goto yy129;
		case 'C':
		case 'c':	goto yy118;
		case 'D':
		case 'd':	goto yy116;
		case 'E':
		case 'e':	goto yy114;
		case 'F':
		case 'f':	goto yy117;
		case 'G':
		case 'g':	goto yy130;
		case 'I':
		case 'i':	goto yy124;
		case 'L':
		case 'l':	goto yy146;
		case 'M':
		case 'm':	goto yy128;
		case 'N':
		case 'n':	goto yy139;
		case 'O':
		case 'o':	goto yy158;
		case 'P':
		case 'p':	goto yy131;
		case 'R':
		case 'r':	goto yy119;
		case 'S':
		case 's':	goto yy127;
		case 'T':
		case 't':	goto yy123;
		case 'U':
		case 'u':	goto yy143;
		case 'V':
		case 'v':	goto yy140;
		case 'W':
		case 'w':	goto yy125;
		case 'X':
		case 'x':	goto yy159;
		case 'Y':
		case 'y':	goto yy122;
		case '[':	goto yy162;
		case '\\':	goto yy173;
		case '^':	goto yy157;
		case '_':	goto yy144;
		case '`':	goto yy179;
		case '{':	goto yy165;
		case '|':	goto yy156;
		case '}':	goto yy167;
		default:	goto yy172;
		}
yy114:
		YYDEBUG(114, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		YYDEBUG(-1, yych);
		switch (yych) {
		case 'C':
		case 'c':	goto yy814;
		case 'L':
		case 'l':	goto yy815;
		case 'M':
		case 'm':	goto yy816;
		case 'N':
		case 'n':	goto yy817;
		case 'V':
		case 'v':	goto yy818;
		case 'X':
		case 'x':	goto yy819;
		default:	goto yy191;
		}
yy115:
		YYDEBUG(115, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_STRING, 0);
}
yy116:
		YYDEBUG(116, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych <= 'H') {
				if (yych == 'E') goto yy796;
				goto yy191;
			} else {
				if (yych <= 'I') goto yy797;
				if (yych <= 'N') goto yy191;
				goto yy798;
			}
		} else {
			if (yych <= 'h') {
				if (yych == 'e') goto yy796;
				goto yy191;
			} else {
				if (yych <= 'i') goto yy797;
				if (yych == 'o') goto yy798;
				goto yy191;
			}
		}
yy117:
		YYDEBUG(117, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'U') {
			if (yych <= 'M') {
				if (yych == 'I') goto yy770;
				goto yy191;
			} else {
				if (yych <= 'N') goto yy771;
				if (yych <= 'O') goto yy773;
				if (yych <= 'T') goto yy191;
				goto yy774;
			}
		} else {
			if (yych <= 'n') {
				if (yych == 'i') goto yy770;
				if (yych <= 'm') goto yy191;
				goto yy771;
			} else {
				if (yych <= 'o') goto yy773;
				if (yych == 'u') goto yy774;
				goto yy191;
			}
		}
yy118:
		YYDEBUG(118, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych <= 'K') {
				if (yych == 'A') goto yy735;
				goto yy191;
			} else {
				if (yych <= 'L') goto yy736;
				if (yych <= 'N') goto yy191;
				goto yy737;
			}
		} else {
			if (yych <= 'k') {
				if (yych == 'a') goto yy735;
				goto yy191;
			} else {
				if (yych <= 'l') goto yy736;
				if (yych == 'o') goto yy737;
				goto yy191;
			}
		}
yy119:
		YYDEBUG(119, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy706;
		if (yych == 'e') goto yy706;
		goto yy191;
yy120:
		YYDEBUG(120, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '[') goto yy704;
yy121:
		YYDEBUG(121, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '\r':
			case '\n':
				YYCURSOR--;
				break;
			case '?':
				if (*YYCURSOR == '>') {
					YYCURSOR--;
					break;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}

		break;
	}

	yyleng = YYCURSOR - SCNG(yy_text);
	RETURN_OR_SKIP_TOKEN(T_COMMENT);
}
yy122:
		YYDEBUG(122, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy691;
		if (yych == 'i') goto yy691;
		goto yy191;
yy123:
		YYDEBUG(123, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'R') {
			if (yych == 'H') goto yy679;
			if (yych <= 'Q') goto yy191;
			goto yy680;
		} else {
			if (yych <= 'h') {
				if (yych <= 'g') goto yy191;
				goto yy679;
			} else {
				if (yych == 'r') goto yy680;
				goto yy191;
			}
		}
yy124:
		YYDEBUG(124, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'L') {
				if (yych == 'F') goto yy626;
				goto yy191;
			} else {
				if (yych <= 'M') goto yy628;
				if (yych <= 'N') goto yy629;
				if (yych <= 'R') goto yy191;
				goto yy630;
			}
		} else {
			if (yych <= 'm') {
				if (yych == 'f') goto yy626;
				if (yych <= 'l') goto yy191;
				goto yy628;
			} else {
				if (yych <= 'n') goto yy629;
				if (yych == 's') goto yy630;
				goto yy191;
			}
		}
yy125:
		YYDEBUG(125, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy621;
		if (yych == 'h') goto yy621;
		goto yy191;
yy126:
		YYDEBUG(126, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'M') {
				if (yych == 'B') goto yy603;
				goto yy191;
			} else {
				if (yych <= 'N') goto yy604;
				if (yych <= 'Q') goto yy191;
				if (yych <= 'R') goto yy605;
				goto yy606;
			}
		} else {
			if (yych <= 'n') {
				if (yych == 'b') goto yy603;
				if (yych <= 'm') goto yy191;
				goto yy604;
			} else {
				if (yych <= 'q') goto yy191;
				if (yych <= 'r') goto yy605;
				if (yych <= 's') goto yy606;
				goto yy191;
			}
		}
yy127:
		YYDEBUG(127, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'W') {
			if (yych == 'T') goto yy591;
			if (yych <= 'V') goto yy191;
			goto yy592;
		} else {
			if (yych <= 't') {
				if (yych <= 's') goto yy191;
				goto yy591;
			} else {
				if (yych == 'w') goto yy592;
				goto yy191;
			}
		}
yy128:
		YYDEBUG(128, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy586;
		if (yych == 'a') goto yy586;
		goto yy191;
yy129:
		YYDEBUG(129, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= ';') {
			if (yych <= '"') {
				if (yych <= '!') goto yy191;
				goto yy578;
			} else {
				if (yych == '\'') goto yy579;
				goto yy191;
			}
		} else {
			if (yych <= 'R') {
				if (yych <= '<') goto yy577;
				if (yych <= 'Q') goto yy191;
				goto yy580;
			} else {
				if (yych == 'r') goto yy580;
				goto yy191;
			}
		}
yy130:
		YYDEBUG(130, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych == 'L') goto yy567;
			if (yych <= 'N') goto yy191;
			goto yy568;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy191;
				goto yy567;
			} else {
				if (yych == 'o') goto yy568;
				goto yy191;
			}
		}
yy131:
		YYDEBUG(131, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'U') {
			if (yych == 'R') goto yy543;
			if (yych <= 'T') goto yy191;
			goto yy544;
		} else {
			if (yych <= 'r') {
				if (yych <= 'q') goto yy191;
				goto yy543;
			} else {
				if (yych == 'u') goto yy544;
				goto yy191;
			}
		}
yy132:
		YYDEBUG(132, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '<') {
			if (yych == '-') goto yy539;
		} else {
			if (yych <= '=') goto yy537;
			if (yych <= '>') goto yy541;
		}
yy133:
		YYDEBUG(133, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(yytext[0]);
}
yy134:
		YYDEBUG(134, *YYCURSOR);
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '=') {
			if (yych == '-') goto yy530;
			goto yy133;
		} else {
			if (yych <= '>') goto yy526;
			if (yych <= '?') goto yy528;
			goto yy133;
		}
yy135:
		YYDEBUG(135, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy525;
yy136:
		YYDEBUG(136, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	goto return_whitespace;
}
yy137:
		YYDEBUG(137, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == ':') goto yy522;
		goto yy133;
yy138:
		YYDEBUG(138, *YYCURSOR);
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '/') {
			if (yych == '.') goto yy516;
			goto yy133;
		} else {
			if (yych <= '9') goto yy512;
			if (yych == '=') goto yy514;
			goto yy133;
		}
yy139:
		YYDEBUG(139, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'E') {
			if (yych == 'A') goto yy496;
			if (yych <= 'D') goto yy191;
			goto yy497;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy191;
				goto yy496;
			} else {
				if (yych == 'e') goto yy497;
				goto yy191;
			}
		}
yy140:
		YYDEBUG(140, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy493;
		if (yych == 'a') goto yy493;
		goto yy191;
yy141:
		YYDEBUG(141, *YYCURSOR);
		yyaccept = 2;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'D') {
				if (yych <= ' ') {
					if (yych == '\t') goto yy414;
					if (yych >= ' ') goto yy414;
				} else {
					if (yych <= '@') goto yy142;
					if (yych != 'C') goto yy414;
				}
			} else {
				if (yych <= 'I') {
					if (yych == 'F') goto yy414;
					if (yych >= 'I') goto yy414;
				} else {
					if (yych == 'O') goto yy414;
					if (yych >= 'R') goto yy414;
				}
			}
		} else {
			if (yych <= 'f') {
				if (yych <= 'b') {
					if (yych == 'U') goto yy414;
					if (yych >= 'a') goto yy414;
				} else {
					if (yych == 'd') goto yy414;
					if (yych >= 'f') goto yy414;
				}
			} else {
				if (yych <= 'o') {
					if (yych == 'i') goto yy414;
					if (yych >= 'o') goto yy414;
				} else {
					if (yych <= 's') {
						if (yych >= 'r') goto yy414;
					} else {
						if (yych == 'u') goto yy414;
					}
				}
			}
		}
yy142:
		YYDEBUG(142, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	enter_nesting(yytext[0]);
	RETURN_TOKEN(yytext[0]);
}
yy143:
		YYDEBUG(143, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'S') {
			if (yych == 'N') goto yy405;
			if (yych <= 'R') goto yy191;
			goto yy406;
		} else {
			if (yych <= 'n') {
				if (yych <= 'm') goto yy191;
				goto yy405;
			} else {
				if (yych == 's') goto yy406;
				goto yy191;
			}
		}
yy144:
		YYDEBUG(144, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy323;
		goto yy191;
yy145:
		YYDEBUG(145, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '<') goto yy133;
		if (yych <= '=') goto yy317;
		if (yych <= '>') goto yy319;
		goto yy133;
yy146:
		YYDEBUG(146, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy313;
		if (yych == 'i') goto yy313;
		goto yy191;
yy147:
		YYDEBUG(147, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '+') goto yy311;
		if (yych == '=') goto yy309;
		goto yy133;
yy148:
		YYDEBUG(148, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy306;
		goto yy133;
yy149:
		YYDEBUG(149, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= ';') goto yy133;
		if (yych <= '<') goto yy282;
		if (yych <= '=') goto yy284;
		if (yych <= '>') goto yy286;
		goto yy133;
yy150:
		YYDEBUG(150, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '<') goto yy133;
		if (yych <= '=') goto yy278;
		if (yych <= '>') goto yy276;
		goto yy133;
yy151:
		YYDEBUG(151, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '*') goto yy270;
		if (yych == '=') goto yy272;
		goto yy133;
yy152:
		YYDEBUG(152, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '.') {
			if (yych == '*') goto yy262;
			goto yy133;
		} else {
			if (yych <= '/') goto yy264;
			if (yych == '=') goto yy265;
			goto yy133;
		}
yy153:
		YYDEBUG(153, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy260;
		goto yy133;
yy154:
		YYDEBUG(154, *YYCURSOR);
		yyaccept = 3;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy250;
		}
		if (yych <= '&') {
			if (yych == '$') goto yy252;
			if (yych >= '&') goto yy255;
		} else {
			if (yych <= '.') {
				if (yych >= '.') goto yy254;
			} else {
				if (yych == '=') goto yy257;
			}
		}
yy155:
		YYDEBUG(155, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_AMPERSAND_NOT_FOLLOWED_BY_VAR_OR_VARARG);
}
yy156:
		YYDEBUG(156, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy248;
		if (yych == '|') goto yy246;
		goto yy133;
yy157:
		YYDEBUG(157, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy244;
		goto yy133;
yy158:
		YYDEBUG(158, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy242;
		if (yych == 'r') goto yy242;
		goto yy191;
yy159:
		YYDEBUG(159, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy239;
		if (yych == 'o') goto yy239;
		goto yy191;
yy160:
		YYDEBUG(160, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(161, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	/* Check that ] and ) match up properly with a preceding [ or ( */
	RETURN_EXIT_NESTING_TOKEN(yytext[0]);
}
yy162:
		YYDEBUG(162, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy142;
yy163:
		YYDEBUG(163, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy133;
			if (yych <= 'Z') goto yy236;
			if (yych <= '^') goto yy133;
			goto yy236;
		} else {
			if (yych <= '`') goto yy133;
			if (yych <= 'z') goto yy236;
			if (yych <= 0x7F) goto yy133;
			goto yy236;
		}
yy164:
		YYDEBUG(164, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy133;
yy165:
		YYDEBUG(165, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(166, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_IN_SCRIPTING);
	enter_nesting('{');
	RETURN_TOKEN('{');
}
yy167:
		YYDEBUG(167, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(168, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RESET_DOC_COMMENT();
	if (!zend_stack_is_empty(&SCNG(state_stack))) {
		yy_pop_state();
	}
	RETURN_EXIT_NESTING_TOKEN('}');
}
yy169:
		YYDEBUG(169, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'X') {
			if (yych <= 'N') {
				if (yych == 'B') goto yy217;
				goto yy200;
			} else {
				if (yych <= 'O') goto yy216;
				if (yych <= 'W') goto yy200;
				goto yy215;
			}
		} else {
			if (yych <= 'n') {
				if (yych == 'b') goto yy217;
				goto yy200;
			} else {
				if (yych <= 'o') goto yy216;
				if (yych == 'x') goto yy215;
				goto yy200;
			}
		}
yy170:
		YYDEBUG(170, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	size_t len = yyleng;
	char *end, *lnum = yytext;
	bool is_octal = lnum[0] == '0';
	bool contains_underscores = (memchr(lnum, '_', len) != NULL);

	if (contains_underscores) {
		lnum = estrndup(lnum, len);
		strip_underscores(lnum, &len);
	}

	/* Digits 8 and 9 are illegal in octal literals. */
	if (is_octal) {
		size_t i;
		for (i = 0; i < len; i++) {
			if (lnum[i] == '8' || lnum[i] == '9') {
				zend_throw_exception(zend_ce_parse_error, "Invalid numeric literal", 0);
				if (PARSER_MODE()) {
					if (contains_underscores) {
						efree(lnum);
					}
					ZVAL_UNDEF(zendlval);
					RETURN_TOKEN(T_ERROR);
				}

				/* Continue in order to determine if this is T_LNUMBER or T_DNUMBER. */
				len = i;
				break;
			}
		}
	}


	if (len < MAX_LENGTH_OF_LONG - 1) { /* Won't overflow */
		errno = 0;
		/* base must be passed explicitly for correct parse error on Windows */
		ZVAL_LONG(zendlval, ZEND_STRTOL(lnum, &end, is_octal ? 8 : 10));
		ZEND_ASSERT(end == lnum + len);
	} else {
		errno = 0;
		ZVAL_LONG(zendlval, ZEND_STRTOL(lnum, &end, 0));
		if (errno == ERANGE) { /* Overflow */
			errno = 0;
			if (is_octal) { /* octal overflow */
				ZVAL_DOUBLE(zendlval, zend_oct_strtod(lnum, (const char **)&end));
			} else {
				ZVAL_DOUBLE(zendlval, zend_strtod(lnum, (const char **)&end));
			}
			ZEND_ASSERT(end == lnum + len);
			if (contains_underscores) {
				efree(lnum);
			}
			RETURN_TOKEN_WITH_VAL(T_DNUMBER);
		}
		ZEND_ASSERT(end == lnum + len);
	}
	ZEND_ASSERT(!errno);
	if (contains_underscores) {
		efree(lnum);
	}
	RETURN_TOKEN_WITH_VAL(T_LNUMBER);
}
yy171:
		YYDEBUG(171, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		goto yy200;
yy172:
		YYDEBUG(172, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		goto yy191;
yy173:
		YYDEBUG(173, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '_') {
			if (yych <= '@') goto yy174;
			if (yych <= 'Z') goto yy183;
			if (yych >= '_') goto yy183;
		} else {
			if (yych <= '`') goto yy174;
			if (yych <= 'z') goto yy183;
			if (yych >= 0x80) goto yy183;
		}
yy174:
		YYDEBUG(174, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_NS_SEPARATOR);
}
yy175:
		YYDEBUG(175, *YYCURSOR);
		++YYCURSOR;
yy176:
		YYDEBUG(176, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	char *s, *t;
	char *end;
	int bprefix = (yytext[0] != '\'') ? 1 : 0;

	while (1) {
		if (YYCURSOR < YYLIMIT) {
			if (*YYCURSOR == '\'') {
				YYCURSOR++;
				yyleng = YYCURSOR - SCNG(yy_text);

				break;
			} else if (*YYCURSOR++ == '\\' && YYCURSOR < YYLIMIT) {
				YYCURSOR++;
			}
		} else {
			yyleng = YYLIMIT - SCNG(yy_text);

			/* Unclosed single quotes; treat similar to double quotes, but without a separate token
			 * for ' (unrecognized by parser), instead of old flex fallback to "Unexpected character..."
			 * rule, which continued in ST_IN_SCRIPTING state after the quote */
			ZVAL_NULL(zendlval);
			RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
		}
	}

	if (yyleng-bprefix-2 <= 1) {
		if (yyleng-bprefix-2 < 1) {
			ZVAL_EMPTY_STRING(zendlval);
		} else {
			zend_uchar c = (zend_uchar)*(yytext+bprefix+1);
			if (c == '\n' || c == '\r') {
				CG(zend_lineno)++;
			}
			ZVAL_INTERNED_STR(zendlval, ZSTR_CHAR(c));
		}
		goto skip_escape_conversion;
	}
	ZVAL_STRINGL(zendlval, yytext+bprefix+1, yyleng-bprefix-2);

	/* convert escape sequences */
	s = Z_STRVAL_P(zendlval);
	end = s+Z_STRLEN_P(zendlval);
	while (1) {
		if (UNEXPECTED(*s=='\\')) {
			break;
		}
		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
		if (s == end) {
			goto skip_escape_conversion;
		}
	}

	t = s;
	while (s<end) {
		if (*s=='\\') {
			s++;
			if (*s == '\\' || *s == '\'') {
				*t++ = *s;
			} else {
				*t++ = '\\';
				*t++ = *s;
			}
		} else {
			*t++ = *s;
		}
		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
	}
	*t = 0;
	Z_STRLEN_P(zendlval) = t - Z_STRVAL_P(zendlval);

skip_escape_conversion:
	if (SCNG(output_filter)) {
		size_t sz = 0;
		char *str = NULL;
		zend_string *new_str;
		s = Z_STRVAL_P(zendlval);
		// TODO: avoid reallocation ???
		SCNG(output_filter)((unsigned char **)&str, &sz, (unsigned char *)s, (size_t)Z_STRLEN_P(zendlval));
		new_str = zend_string_init(str, sz, 0);
		if (str != s) {
			efree(str);
		}
		zend_string_release_ex(Z_STR_P(zendlval), 0);
		ZVAL_STR(zendlval, new_str);
	}
	RETURN_TOKEN_WITH_VAL(T_CONSTANT_ENCAPSED_STRING);
}
yy177:
		YYDEBUG(177, *YYCURSOR);
		++YYCURSOR;
yy178:
		YYDEBUG(178, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	int bprefix = (yytext[0] != '"') ? 1 : 0;

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '"':
				yyleng = YYCURSOR - SCNG(yy_text);
				if (EXPECTED(zend_scan_escape_string(zendlval, yytext+bprefix+1, yyleng-bprefix-2, '"') == SUCCESS)
				 || !PARSER_MODE()) {
					RETURN_TOKEN_WITH_VAL(T_CONSTANT_ENCAPSED_STRING);
				} else {
					RETURN_TOKEN(T_ERROR);
				}
			case '$':
				if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
					break;
				}
				continue;
			case '{':
				if (*YYCURSOR == '$') {
					break;
				}
				continue;
			case '\\':
				if (YYCURSOR < YYLIMIT) {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}

		YYCURSOR--;
		break;
	}

	/* Remember how much was scanned to save rescanning */
	SET_DOUBLE_QUOTES_SCANNED_LENGTH(YYCURSOR - SCNG(yy_text) - yyleng);

	YYCURSOR = SCNG(yy_text) + yyleng;

	BEGIN(ST_DOUBLE_QUOTES);
	RETURN_TOKEN('"');
}
yy179:
		YYDEBUG(179, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(180, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	BEGIN(ST_BACKQUOTE);
	RETURN_TOKEN('`');
}
yy181:
		YYDEBUG(181, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(182, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}

	RETURN_TOKEN(T_BAD_CHARACTER);
}
yy183:
		YYDEBUG(183, *YYCURSOR);
		yyaccept = 5;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(184, *YYCURSOR);
		if (yybm[0+yych] & 2) {
			goto yy183;
		}
		if (yych == '\\') goto yy186;
yy185:
		YYDEBUG(185, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_NAME_FULLY_QUALIFIED, 1);
}
yy186:
		YYDEBUG(186, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy187;
			if (yych <= 'Z') goto yy188;
			if (yych >= '_') goto yy188;
		} else {
			if (yych <= '`') goto yy187;
			if (yych <= 'z') goto yy188;
			if (yych >= 0x80) goto yy188;
		}
yy187:
		YYDEBUG(187, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept <= 46) {
			if (yyaccept <= 23) {
				if (yyaccept <= 11) {
					if (yyaccept <= 5) {
						if (yyaccept <= 2) {
							if (yyaccept <= 1) {
								if (yyaccept == 0) {
									goto yy115;
								} else {
									goto yy133;
								}
							} else {
								goto yy142;
							}
						} else {
							if (yyaccept <= 4) {
								if (yyaccept == 3) {
									goto yy155;
								} else {
									goto yy170;
								}
							} else {
								goto yy185;
							}
						}
					} else {
						if (yyaccept <= 8) {
							if (yyaccept <= 7) {
								if (yyaccept == 6) {
									goto yy195;
								} else {
									goto yy198;
								}
							} else {
								goto yy220;
							}
						} else {
							if (yyaccept <= 10) {
								if (yyaccept == 9) {
									goto yy226;
								} else {
									goto yy232;
								}
							} else {
								goto yy241;
							}
						}
					}
				} else {
					if (yyaccept <= 17) {
						if (yyaccept <= 14) {
							if (yyaccept <= 13) {
								if (yyaccept == 12) {
									goto yy243;
								} else {
									goto yy263;
								}
							} else {
								goto yy283;
							}
						} else {
							if (yyaccept <= 16) {
								if (yyaccept == 15) {
									goto yy316;
								} else {
									goto yy342;
								}
							} else {
								goto yy347;
							}
						}
					} else {
						if (yyaccept <= 20) {
							if (yyaccept <= 19) {
								if (yyaccept == 18) {
									goto yy353;
								} else {
									goto yy361;
								}
							} else {
								goto yy372;
							}
						} else {
							if (yyaccept <= 22) {
								if (yyaccept == 21) {
									goto yy377;
								} else {
									goto yy384;
								}
							} else {
								goto yy391;
							}
						}
					}
				}
			} else {
				if (yyaccept <= 35) {
					if (yyaccept <= 29) {
						if (yyaccept <= 26) {
							if (yyaccept <= 25) {
								if (yyaccept == 24) {
									goto yy404;
								} else {
									goto yy408;
								}
							} else {
								goto yy412;
							}
						} else {
							if (yyaccept <= 28) {
								if (yyaccept == 27) {
									goto yy495;
								} else {
									goto yy499;
								}
							} else {
								goto yy507;
							}
						}
					} else {
						if (yyaccept <= 32) {
							if (yyaccept <= 31) {
								if (yyaccept == 30) {
									goto yy511;
								} else {
									goto yy549;
								}
							} else {
								goto yy558;
							}
						} else {
							if (yyaccept <= 34) {
								if (yyaccept == 33) {
									goto yy564;
								} else {
									goto yy566;
								}
							} else {
								goto yy571;
							}
						}
					}
				} else {
					if (yyaccept <= 41) {
						if (yyaccept <= 38) {
							if (yyaccept <= 37) {
								if (yyaccept == 36) {
									goto yy576;
								} else {
									goto yy584;
								}
							} else {
								goto yy590;
							}
						} else {
							if (yyaccept <= 40) {
								if (yyaccept == 39) {
									goto yy597;
								} else {
									goto yy602;
								}
							} else {
								goto yy607;
							}
						}
					} else {
						if (yyaccept <= 44) {
							if (yyaccept <= 43) {
								if (yyaccept == 42) {
									goto yy611;
								} else {
									goto yy613;
								}
							} else {
								goto yy620;
							}
						} else {
							if (yyaccept == 45) {
								goto yy625;
							} else {
								goto yy627;
							}
						}
					}
				}
			}
		} else {
			if (yyaccept <= 69) {
				if (yyaccept <= 58) {
					if (yyaccept <= 52) {
						if (yyaccept <= 49) {
							if (yyaccept <= 48) {
								if (yyaccept == 47) {
									goto yy634;
								} else {
									goto yy642;
								}
							} else {
								goto yy648;
							}
						} else {
							if (yyaccept <= 51) {
								if (yyaccept == 50) {
									goto yy655;
								} else {
									goto yy663;
								}
							} else {
								goto yy669;
							}
						}
					} else {
						if (yyaccept <= 55) {
							if (yyaccept <= 54) {
								if (yyaccept == 53) {
									goto yy678;
								} else {
									goto yy682;
								}
							} else {
								goto yy686;
							}
						} else {
							if (yyaccept <= 57) {
								if (yyaccept == 56) {
									goto yy690;
								} else {
									goto yy695;
								}
							} else {
								goto yy715;
							}
						}
					}
				} else {
					if (yyaccept <= 64) {
						if (yyaccept <= 61) {
							if (yyaccept <= 60) {
								if (yyaccept == 59) {
									goto yy724;
								} else {
									goto yy730;
								}
							} else {
								goto yy734;
							}
						} else {
							if (yyaccept <= 63) {
								if (yyaccept == 62) {
									goto yy745;
								} else {
									goto yy747;
								}
							} else {
								goto yy752;
							}
						}
					} else {
						if (yyaccept <= 67) {
							if (yyaccept <= 66) {
								if (yyaccept == 65) {
									goto yy755;
								} else {
									goto yy764;
								}
							} else {
								goto yy766;
							}
						} else {
							if (yyaccept == 68) {
								goto yy769;
							} else {
								goto yy772;
							}
						}
					}
				}
			} else {
				if (yyaccept <= 81) {
					if (yyaccept <= 75) {
						if (yyaccept <= 72) {
							if (yyaccept <= 71) {
								if (yyaccept == 70) {
									goto yy781;
								} else {
									goto yy783;
								}
							} else {
								goto yy788;
							}
						} else {
							if (yyaccept <= 74) {
								if (yyaccept == 73) {
									goto yy792;
								} else {
									goto yy795;
								}
							} else {
								goto yy799;
							}
						}
					} else {
						if (yyaccept <= 78) {
							if (yyaccept <= 77) {
								if (yyaccept == 76) {
									goto yy801;
								} else {
									goto yy808;
								}
							} else {
								goto yy813;
							}
						} else {
							if (yyaccept <= 80) {
								if (yyaccept == 79) {
									goto yy826;
								} else {
									goto yy828;
								}
							} else {
								goto yy831;
							}
						}
					}
				} else {
					if (yyaccept <= 87) {
						if (yyaccept <= 84) {
							if (yyaccept <= 83) {
								if (yyaccept == 82) {
									goto yy838;
								} else {
									goto yy865;
								}
							} else {
								goto yy871;
							}
						} else {
							if (yyaccept <= 86) {
								if (yyaccept == 85) {
									goto yy873;
								} else {
									goto yy876;
								}
							} else {
								goto yy881;
							}
						}
					} else {
						if (yyaccept <= 90) {
							if (yyaccept <= 89) {
								if (yyaccept == 88) {
									goto yy888;
								} else {
									goto yy892;
								}
							} else {
								goto yy895;
							}
						} else {
							if (yyaccept == 91) {
								goto yy898;
							} else {
								goto yy901;
							}
						}
					}
				}
			}
		}
yy188:
		YYDEBUG(188, *YYCURSOR);
		yyaccept = 5;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(189, *YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy185;
				if (yych <= '9') goto yy188;
				goto yy185;
			} else {
				if (yych <= 'Z') goto yy188;
				if (yych <= '[') goto yy185;
				goto yy186;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy188;
				goto yy185;
			} else {
				if (yych <= 'z') goto yy188;
				if (yych <= 0x7F) goto yy185;
				goto yy188;
			}
		}
yy190:
		YYDEBUG(190, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy191:
		YYDEBUG(191, *YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy115;
				if (yych <= '9') goto yy190;
				goto yy115;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych <= '[') goto yy115;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
				goto yy115;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych <= 0x7F) goto yy115;
				goto yy190;
			}
		}
yy192:
		YYDEBUG(192, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy187;
			if (yych <= 'Z') goto yy193;
			if (yych <= '^') goto yy187;
		} else {
			if (yych <= '`') goto yy187;
			if (yych <= 'z') goto yy193;
			if (yych <= 0x7F) goto yy187;
		}
yy193:
		YYDEBUG(193, *YYCURSOR);
		yyaccept = 6;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(194, *YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy195;
				if (yych <= '9') goto yy193;
			} else {
				if (yych <= 'Z') goto yy193;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy193;
			} else {
				if (yych <= 'z') goto yy193;
				if (yych >= 0x80) goto yy193;
			}
		}
yy195:
		YYDEBUG(195, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_NAME_QUALIFIED, 0);
}
yy196:
		YYDEBUG(196, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy187;
		if (yych <= '9') goto yy213;
		goto yy187;
yy197:
		YYDEBUG(197, *YYCURSOR);
		yyaccept = 7;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy209;
yy198:
		YYDEBUG(198, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	const char *end;
	size_t len = yyleng;
	char *dnum = yytext;
	bool contains_underscores = (memchr(dnum, '_', len) != NULL);

	if (contains_underscores) {
		dnum = estrndup(dnum, len);
		strip_underscores(dnum, &len);
	}

	ZVAL_DOUBLE(zendlval, zend_strtod(dnum, &end));
	/* errno isn't checked since we allow HUGE_VAL/INF overflow */
	ZEND_ASSERT(end == dnum + len);
	if (contains_underscores) {
		efree(dnum);
	}
	RETURN_TOKEN_WITH_VAL(T_DNUMBER);
}
yy199:
		YYDEBUG(199, *YYCURSOR);
		yyaccept = 4;
		YYMARKER = ++YYCURSOR;
		YYFILL(4);
		yych = *YYCURSOR;
yy200:
		YYDEBUG(200, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy199;
		}
		if (yych <= 'E') {
			if (yych == '.') goto yy197;
			if (yych <= 'D') goto yy170;
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy170;
				goto yy196;
			} else {
				if (yych != 'e') goto yy170;
			}
		}
yy201:
		YYDEBUG(201, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= ',') {
			if (yych != '+') goto yy187;
		} else {
			if (yych <= '-') goto yy202;
			if (yych <= '/') goto yy187;
			if (yych <= '9') goto yy203;
			goto yy187;
		}
yy202:
		YYDEBUG(202, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '/') goto yy187;
		if (yych >= ':') goto yy187;
yy203:
		YYDEBUG(203, *YYCURSOR);
		yyaccept = 7;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(204, *YYCURSOR);
		if (yych <= '/') goto yy198;
		if (yych <= '9') goto yy203;
		if (yych != '_') goto yy198;
yy205:
		YYDEBUG(205, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy187;
		if (yych >= ':') goto yy187;
yy206:
		YYDEBUG(206, *YYCURSOR);
		yyaccept = 7;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(207, *YYCURSOR);
		if (yych <= '/') goto yy198;
		if (yych <= '9') goto yy206;
		if (yych == '_') goto yy205;
		goto yy198;
yy208:
		YYDEBUG(208, *YYCURSOR);
		yyaccept = 7;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
yy209:
		YYDEBUG(209, *YYCURSOR);
		if (yych <= 'E') {
			if (yych <= '/') goto yy198;
			if (yych <= '9') goto yy208;
			if (yych <= 'D') goto yy198;
			goto yy201;
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy198;
			} else {
				if (yych == 'e') goto yy201;
				goto yy198;
			}
		}
yy210:
		YYDEBUG(210, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy187;
		if (yych >= ':') goto yy187;
yy211:
		YYDEBUG(211, *YYCURSOR);
		yyaccept = 7;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(212, *YYCURSOR);
		if (yych <= 'E') {
			if (yych <= '/') goto yy198;
			if (yych <= '9') goto yy211;
			if (yych <= 'D') goto yy198;
			goto yy201;
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy198;
				goto yy210;
			} else {
				if (yych == 'e') goto yy201;
				goto yy198;
			}
		}
yy213:
		YYDEBUG(213, *YYCURSOR);
		yyaccept = 4;
		YYMARKER = ++YYCURSOR;
		YYFILL(4);
		yych = *YYCURSOR;
		YYDEBUG(214, *YYCURSOR);
		if (yych <= 'D') {
			if (yych <= '.') {
				if (yych <= '-') goto yy170;
				goto yy197;
			} else {
				if (yych <= '/') goto yy170;
				if (yych <= '9') goto yy213;
				goto yy170;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'E') goto yy201;
				if (yych <= '^') goto yy170;
				goto yy196;
			} else {
				if (yych == 'e') goto yy201;
				goto yy170;
			}
		}
yy215:
		YYDEBUG(215, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy230;
		}
		goto yy187;
yy216:
		YYDEBUG(216, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy224;
		}
		goto yy187;
yy217:
		YYDEBUG(217, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 8) {
			goto yy218;
		}
		goto yy187;
yy218:
		YYDEBUG(218, *YYCURSOR);
		yyaccept = 8;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(219, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy218;
		}
		if (yych == '_') goto yy221;
yy220:
		YYDEBUG(220, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	/* The +/- 2 skips "0b" */
	size_t len = yyleng - 2;
	char *end, *bin = yytext + 2;
	bool contains_underscores;

	/* Skip any leading 0s */
	while (len > 0 && (*bin == '0' || *bin == '_')) {
		++bin;
		--len;
	}

	contains_underscores = (memchr(bin, '_', len) != NULL);

	if (contains_underscores) {
		bin = estrndup(bin, len);
		strip_underscores(bin, &len);
	}

	if (len < SIZEOF_ZEND_LONG * 8) {
		if (len == 0) {
			ZVAL_LONG(zendlval, 0);
		} else {
			errno = 0;
			ZVAL_LONG(zendlval, ZEND_STRTOL(bin, &end, 2));
			ZEND_ASSERT(!errno && end == bin + len);
		}
		if (contains_underscores) {
			efree(bin);
		}
		RETURN_TOKEN_WITH_VAL(T_LNUMBER);
	} else {
		ZVAL_DOUBLE(zendlval, zend_bin_strtod(bin, (const char **)&end));
		/* errno isn't checked since we allow HUGE_VAL/INF overflow */
		ZEND_ASSERT(end == bin + len);
		if (contains_underscores) {
			efree(bin);
		}
		RETURN_TOKEN_WITH_VAL(T_DNUMBER);
	}
}
yy221:
		YYDEBUG(221, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy187;
		if (yych >= '2') goto yy187;
yy222:
		YYDEBUG(222, *YYCURSOR);
		yyaccept = 8;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(223, *YYCURSOR);
		if (yych <= '/') goto yy220;
		if (yych <= '1') goto yy222;
		if (yych == '_') goto yy221;
		goto yy220;
yy224:
		YYDEBUG(224, *YYCURSOR);
		yyaccept = 9;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(225, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy224;
		}
		if (yych == '_') goto yy227;
yy226:
		YYDEBUG(226, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	/* The +/- 2 skips "0o" */
	size_t len = yyleng - 2;
	char *end, *octal = yytext + 2;
	bool contains_underscores = (memchr(octal, '_', len) != NULL);

	/* Skip any leading 0s */
	while (len > 0 && (*octal == '0' || *octal == '_')) {
		++octal;
		--len;
	}

	if (len == 0) {
		ZVAL_LONG(zendlval, 0);
		RETURN_TOKEN_WITH_VAL(T_LNUMBER);
	}

	if (contains_underscores) {
		octal = estrndup(octal, len);
		strip_underscores(octal, &len);
	}

	errno = 0;

	ZVAL_LONG(zendlval, ZEND_STRTOL(octal, &end, 8));

	ZEND_ASSERT(end == octal + len);

	if (!errno) {
		if (contains_underscores) {
			efree(octal);
		}
		RETURN_TOKEN_WITH_VAL(T_LNUMBER);
	}

	/* Overflow */
	ZEND_ASSERT(errno == ERANGE);
	/* Reset errno */
	errno = 0;

	/* zend_oct_strtod skips leading '0' */
	ZVAL_DOUBLE(zendlval, zend_oct_strtod(octal, (const char **)&end));
	ZEND_ASSERT(!errno);
	ZEND_ASSERT(end == octal + len);
	if (contains_underscores) {
		efree(octal);
	}
	RETURN_TOKEN_WITH_VAL(T_DNUMBER);
}
yy227:
		YYDEBUG(227, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy187;
		if (yych >= '8') goto yy187;
yy228:
		YYDEBUG(228, *YYCURSOR);
		yyaccept = 9;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(229, *YYCURSOR);
		if (yych <= '/') goto yy226;
		if (yych <= '7') goto yy228;
		if (yych == '_') goto yy227;
		goto yy226;
yy230:
		YYDEBUG(230, *YYCURSOR);
		yyaccept = 10;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(231, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy230;
		}
		if (yych == '_') goto yy233;
yy232:
		YYDEBUG(232, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	/* The +/- 2 skips "0x" */
	size_t len = yyleng - 2;
	char *end, *hex = yytext + 2;
	bool contains_underscores;

	/* Skip any leading 0s */
	while (len > 0 && (*hex == '0' || *hex == '_')) {
		++hex;
		--len;
	}

	contains_underscores = (memchr(hex, '_', len) != NULL);

	if (contains_underscores) {
		hex = estrndup(hex, len);
		strip_underscores(hex, &len);
	}

	if (len < SIZEOF_ZEND_LONG * 2 || (len == SIZEOF_ZEND_LONG * 2 && *hex <= '7')) {
		if (len == 0) {
			ZVAL_LONG(zendlval, 0);
		} else {
			errno = 0;
			ZVAL_LONG(zendlval, ZEND_STRTOL(hex, &end, 16));
			ZEND_ASSERT(!errno && end == hex + len);
		}
		if (contains_underscores) {
			efree(hex);
		}
		RETURN_TOKEN_WITH_VAL(T_LNUMBER);
	} else {
		ZVAL_DOUBLE(zendlval, zend_hex_strtod(hex, (const char **)&end));
		/* errno isn't checked since we allow HUGE_VAL/INF overflow */
		ZEND_ASSERT(end == hex + len);
		if (contains_underscores) {
			efree(hex);
		}
		RETURN_TOKEN_WITH_VAL(T_DNUMBER);
	}
}
yy233:
		YYDEBUG(233, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '@') {
			if (yych <= '/') goto yy187;
			if (yych >= ':') goto yy187;
		} else {
			if (yych <= 'F') goto yy234;
			if (yych <= '`') goto yy187;
			if (yych >= 'g') goto yy187;
		}
yy234:
		YYDEBUG(234, *YYCURSOR);
		yyaccept = 10;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(235, *YYCURSOR);
		if (yych <= 'F') {
			if (yych <= '/') goto yy232;
			if (yych <= '9') goto yy234;
			if (yych <= '@') goto yy232;
			goto yy234;
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy232;
				goto yy233;
			} else {
				if (yych <= '`') goto yy232;
				if (yych <= 'f') goto yy234;
				goto yy232;
			}
		}
yy236:
		YYDEBUG(236, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(237, *YYCURSOR);
		if (yych <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy236;
			} else {
				if (yych <= '@') goto yy238;
				if (yych <= 'Z') goto yy236;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy236;
			} else {
				if (yych <= 'z') goto yy236;
				if (yych >= 0x80) goto yy236;
			}
		}
yy238:
		YYDEBUG(238, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy239:
		YYDEBUG(239, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy240;
		if (yych != 'r') goto yy191;
yy240:
		YYDEBUG(240, *YYCURSOR);
		yyaccept = 11;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy241;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy241:
		YYDEBUG(241, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_LOGICAL_XOR);
}
yy242:
		YYDEBUG(242, *YYCURSOR);
		yyaccept = 12;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy243;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy243:
		YYDEBUG(243, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_LOGICAL_OR);
}
yy244:
		YYDEBUG(244, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(245, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_XOR_EQUAL);
}
yy246:
		YYDEBUG(246, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(247, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_BOOLEAN_OR);
}
yy248:
		YYDEBUG(248, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(249, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_OR_EQUAL);
}
yy250:
		YYDEBUG(250, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(251, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy250;
		}
		if (yych == '$') goto yy252;
		if (yych == '.') goto yy254;
		goto yy187;
yy252:
		YYDEBUG(252, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(253, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(1);
	RETURN_TOKEN(T_AMPERSAND_FOLLOWED_BY_VAR_OR_VARARG);
}
yy254:
		YYDEBUG(254, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '.') goto yy259;
		goto yy187;
yy255:
		YYDEBUG(255, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(256, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_BOOLEAN_AND);
}
yy257:
		YYDEBUG(257, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(258, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_AND_EQUAL);
}
yy259:
		YYDEBUG(259, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '.') goto yy252;
		goto yy187;
yy260:
		YYDEBUG(260, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(261, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_MOD_EQUAL);
}
yy262:
		YYDEBUG(262, *YYCURSOR);
		yyaccept = 13;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '*') goto yy267;
yy263:
		YYDEBUG(263, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	int doc_com;

	if (yyleng > 2) {
		doc_com = 1;
		RESET_DOC_COMMENT();
	} else {
		doc_com = 0;
	}

	while (YYCURSOR < YYLIMIT) {
		if (*YYCURSOR++ == '*' && *YYCURSOR == '/') {
			break;
		}
	}

	if (YYCURSOR < YYLIMIT) {
		YYCURSOR++;
	} else {
		zend_throw_exception_ex(zend_ce_parse_error, 0, "Unterminated comment starting line %d", CG(zend_lineno));
		if (PARSER_MODE()) {
			RETURN_TOKEN(T_ERROR);
		}
	}

	yyleng = YYCURSOR - SCNG(yy_text);
	HANDLE_NEWLINES(yytext, yyleng);

	if (doc_com) {
		CG(doc_comment) = zend_string_init(yytext, yyleng, 0);
		RETURN_OR_SKIP_TOKEN(T_DOC_COMMENT);
	}

	RETURN_OR_SKIP_TOKEN(T_COMMENT);
}
yy264:
		YYDEBUG(264, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy121;
yy265:
		YYDEBUG(265, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(266, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_DIV_EQUAL);
}
yy267:
		YYDEBUG(267, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '\f') {
			if (yych <= 0x08) goto yy187;
			if (yych >= '\v') goto yy187;
		} else {
			if (yych <= '\r') goto yy268;
			if (yych != ' ') goto yy187;
		}
yy268:
		YYDEBUG(268, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(269, *YYCURSOR);
		if (yych <= '\f') {
			if (yych <= 0x08) goto yy263;
			if (yych <= '\n') goto yy268;
			goto yy263;
		} else {
			if (yych <= '\r') goto yy268;
			if (yych == ' ') goto yy268;
			goto yy263;
		}
yy270:
		YYDEBUG(270, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy274;
		YYDEBUG(271, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_POW);
}
yy272:
		YYDEBUG(272, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(273, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_MUL_EQUAL);
}
yy274:
		YYDEBUG(274, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(275, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_POW_EQUAL);
}
yy276:
		YYDEBUG(276, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy280;
		YYDEBUG(277, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_SR);
}
yy278:
		YYDEBUG(278, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(279, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_IS_GREATER_OR_EQUAL);
}
yy280:
		YYDEBUG(280, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(281, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_SR_EQUAL);
}
yy282:
		YYDEBUG(282, *YYCURSOR);
		yyaccept = 14;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= ';') goto yy283;
		if (yych <= '<') goto yy292;
		if (yych <= '=') goto yy290;
yy283:
		YYDEBUG(283, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_SL);
}
yy284:
		YYDEBUG(284, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '>') goto yy288;
		YYDEBUG(285, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_IS_SMALLER_OR_EQUAL);
}
yy286:
		YYDEBUG(286, *YYCURSOR);
		++YYCURSOR;
yy287:
		YYDEBUG(287, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_IS_NOT_EQUAL);
}
yy288:
		YYDEBUG(288, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(289, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_SPACESHIP);
}
yy290:
		YYDEBUG(290, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(291, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_SL_EQUAL);
}
yy292:
		YYDEBUG(292, *YYCURSOR);
		++YYCURSOR;
		YYFILL(2);
		yych = *YYCURSOR;
		YYDEBUG(293, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy292;
		}
		if (yych <= 'Z') {
			if (yych <= '&') {
				if (yych == '"') goto yy297;
				goto yy187;
			} else {
				if (yych <= '\'') goto yy296;
				if (yych <= '@') goto yy187;
			}
		} else {
			if (yych <= '`') {
				if (yych != '_') goto yy187;
			} else {
				if (yych <= 'z') goto yy294;
				if (yych <= 0x7F) goto yy187;
			}
		}
yy294:
		YYDEBUG(294, *YYCURSOR);
		++YYCURSOR;
		YYFILL(2);
		yych = *YYCURSOR;
		YYDEBUG(295, *YYCURSOR);
		if (yych <= '@') {
			if (yych <= '\f') {
				if (yych == '\n') goto yy301;
				goto yy187;
			} else {
				if (yych <= '\r') goto yy303;
				if (yych <= '/') goto yy187;
				if (yych <= '9') goto yy294;
				goto yy187;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'Z') goto yy294;
				if (yych <= '^') goto yy187;
				goto yy294;
			} else {
				if (yych <= '`') goto yy187;
				if (yych <= 'z') goto yy294;
				if (yych <= 0x7F) goto yy187;
				goto yy294;
			}
		}
yy296:
		YYDEBUG(296, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\'') goto yy187;
		if (yych <= '/') goto yy305;
		if (yych <= '9') goto yy187;
		goto yy305;
yy297:
		YYDEBUG(297, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '"') goto yy187;
		if (yych <= '/') goto yy299;
		if (yych <= '9') goto yy187;
		goto yy299;
yy298:
		YYDEBUG(298, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
yy299:
		YYDEBUG(299, *YYCURSOR);
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych != '"') goto yy187;
			} else {
				if (yych <= '9') goto yy298;
				if (yych <= '@') goto yy187;
				goto yy298;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy298;
				goto yy187;
			} else {
				if (yych <= 'z') goto yy298;
				if (yych <= 0x7F) goto yy187;
				goto yy298;
			}
		}
yy300:
		YYDEBUG(300, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy301;
		if (yych == '\r') goto yy303;
		goto yy187;
yy301:
		YYDEBUG(301, *YYCURSOR);
		++YYCURSOR;
yy302:
		YYDEBUG(302, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	char *s;
	unsigned char *saved_cursor;
	int bprefix = (yytext[0] != '<') ? 1 : 0, spacing = 0, indentation = 0;
	zend_heredoc_label *heredoc_label = emalloc(sizeof(zend_heredoc_label));
	bool is_heredoc = 1;

	CG(zend_lineno)++;
	heredoc_label->length = yyleng-bprefix-3-1-(yytext[yyleng-2]=='\r'?1:0);
	s = yytext+bprefix+3;
	while ((*s == ' ') || (*s == '\t')) {
		s++;
		heredoc_label->length--;
	}

	if (*s == '\'') {
		s++;
		heredoc_label->length -= 2;
		is_heredoc = 0;

		BEGIN(ST_NOWDOC);
	} else {
		if (*s == '"') {
			s++;
			heredoc_label->length -= 2;
		}

		BEGIN(ST_HEREDOC);
	}

	heredoc_label->label = estrndup(s, heredoc_label->length);
	heredoc_label->indentation_uses_spaces = 0;
	heredoc_label->indentation = 0;
	saved_cursor = YYCURSOR;

	zend_ptr_stack_push(&SCNG(heredoc_label_stack), (void *) heredoc_label);

	while (YYCURSOR < YYLIMIT && (*YYCURSOR == ' ' || *YYCURSOR == '\t')) {
		if (*YYCURSOR == '\t') {
			spacing |= HEREDOC_USING_TABS;
		} else {
			spacing |= HEREDOC_USING_SPACES;
		}
		++YYCURSOR;
		++indentation;
	}

	if (YYCURSOR == YYLIMIT) {
		YYCURSOR = saved_cursor;
		RETURN_TOKEN(T_START_HEREDOC);
	}

	/* Check for ending label on the next line */
	if (heredoc_label->length < YYLIMIT - YYCURSOR && !memcmp(YYCURSOR, s, heredoc_label->length)) {
		if (!IS_LABEL_SUCCESSOR(YYCURSOR[heredoc_label->length])) {
			if (spacing == (HEREDOC_USING_SPACES | HEREDOC_USING_TABS)) {
				zend_throw_exception(zend_ce_parse_error, "Invalid indentation - tabs and spaces cannot be mixed", 0);
				if (PARSER_MODE()) {
					RETURN_TOKEN(T_ERROR);
				}
			}

			YYCURSOR = saved_cursor;
			heredoc_label->indentation = indentation;

			BEGIN(ST_END_HEREDOC);
			RETURN_TOKEN(T_START_HEREDOC);
		}
	}

	YYCURSOR = saved_cursor;

	if (is_heredoc && !SCNG(heredoc_scan_ahead)) {
		zend_lex_state current_state;
		zend_string *saved_doc_comment = CG(doc_comment);
		int heredoc_nesting_level = 1;
		int first_token = 0;
		int error = 0;

		zend_save_lexical_state(&current_state);

		SCNG(heredoc_scan_ahead) = 1;
		SCNG(heredoc_indentation) = 0;
		SCNG(heredoc_indentation_uses_spaces) = 0;
		LANG_SCNG(on_event) = NULL;
		CG(doc_comment) = NULL;

		zend_ptr_stack_reverse_apply(&current_state.heredoc_label_stack, copy_heredoc_label_stack);

		zend_exception_save();
		while (heredoc_nesting_level) {
			zval zv;
			int retval;

			ZVAL_UNDEF(&zv);
			retval = lex_scan(&zv, NULL);
			zval_ptr_dtor_nogc(&zv);

			if (EG(exception)) {
				zend_clear_exception();
				break;
			}

			if (!first_token) {
				first_token = retval;
			}

			switch (retval) {
				case T_START_HEREDOC:
					++heredoc_nesting_level;
					break;
				case T_END_HEREDOC:
					--heredoc_nesting_level;
					break;
				case END:
					heredoc_nesting_level = 0;
			}
		}
		zend_exception_restore();

		if (
		    (first_token == T_VARIABLE
		     || first_token == T_DOLLAR_OPEN_CURLY_BRACES
		     || first_token == T_CURLY_OPEN
		    ) && SCNG(heredoc_indentation)) {
			zend_throw_exception_ex(zend_ce_parse_error, 0, "Invalid body indentation level (expecting an indentation level of at least %d)", SCNG(heredoc_indentation));
			error = 1;
		}

		heredoc_label->indentation = SCNG(heredoc_indentation);
		heredoc_label->indentation_uses_spaces = SCNG(heredoc_indentation_uses_spaces);

		zend_restore_lexical_state(&current_state);
		SCNG(heredoc_scan_ahead) = 0;
		CG(increment_lineno) = 0;
		CG(doc_comment) = saved_doc_comment;

		if (PARSER_MODE() && error) {
			RETURN_TOKEN(T_ERROR);
		}
	}

	RETURN_TOKEN(T_START_HEREDOC);
}
yy303:
		YYDEBUG(303, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy301;
		goto yy302;
yy304:
		YYDEBUG(304, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
yy305:
		YYDEBUG(305, *YYCURSOR);
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych == '\'') goto yy300;
				goto yy187;
			} else {
				if (yych <= '9') goto yy304;
				if (yych <= '@') goto yy187;
				goto yy304;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy304;
				goto yy187;
			} else {
				if (yych <= 'z') goto yy304;
				if (yych <= 0x7F) goto yy187;
				goto yy304;
			}
		}
yy306:
		YYDEBUG(306, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '=') goto yy287;
		YYDEBUG(307, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(308, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_IS_NOT_IDENTICAL);
}
yy309:
		YYDEBUG(309, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(310, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_PLUS_EQUAL);
}
yy311:
		YYDEBUG(311, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(312, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_INC);
}
yy313:
		YYDEBUG(313, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy314;
		if (yych != 's') goto yy191;
yy314:
		YYDEBUG(314, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy315;
		if (yych != 't') goto yy191;
yy315:
		YYDEBUG(315, *YYCURSOR);
		yyaccept = 15;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy316;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy316:
		YYDEBUG(316, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_LIST);
}
yy317:
		YYDEBUG(317, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy321;
		YYDEBUG(318, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_IS_EQUAL);
}
yy319:
		YYDEBUG(319, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(320, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_DOUBLE_ARROW);
}
yy321:
		YYDEBUG(321, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(322, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_IS_IDENTICAL);
}
yy323:
		YYDEBUG(323, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		YYDEBUG(-1, yych);
		switch (yych) {
		case 'C':
		case 'c':	goto yy325;
		case 'D':
		case 'd':	goto yy330;
		case 'F':
		case 'f':	goto yy327;
		case 'H':
		case 'h':	goto yy324;
		case 'L':
		case 'l':	goto yy329;
		case 'M':
		case 'm':	goto yy328;
		case 'N':
		case 'n':	goto yy331;
		case 'T':
		case 't':	goto yy326;
		default:	goto yy191;
		}
yy324:
		YYDEBUG(324, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy392;
		if (yych == 'a') goto yy392;
		goto yy191;
yy325:
		YYDEBUG(325, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy385;
		if (yych == 'l') goto yy385;
		goto yy191;
yy326:
		YYDEBUG(326, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy378;
		if (yych == 'r') goto yy378;
		goto yy191;
yy327:
		YYDEBUG(327, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'U') {
			if (yych == 'I') goto yy362;
			if (yych <= 'T') goto yy191;
			goto yy363;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy191;
				goto yy362;
			} else {
				if (yych == 'u') goto yy363;
				goto yy191;
			}
		}
yy328:
		YYDEBUG(328, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy354;
		if (yych == 'e') goto yy354;
		goto yy191;
yy329:
		YYDEBUG(329, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy348;
		if (yych == 'i') goto yy348;
		goto yy191;
yy330:
		YYDEBUG(330, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy343;
		if (yych == 'i') goto yy343;
		goto yy191;
yy331:
		YYDEBUG(331, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy332;
		if (yych != 'a') goto yy191;
yy332:
		YYDEBUG(332, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy333;
		if (yych != 'm') goto yy191;
yy333:
		YYDEBUG(333, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy334;
		if (yych != 'e') goto yy191;
yy334:
		YYDEBUG(334, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy335;
		if (yych != 's') goto yy191;
yy335:
		YYDEBUG(335, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'P') goto yy336;
		if (yych != 'p') goto yy191;
yy336:
		YYDEBUG(336, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy337;
		if (yych != 'a') goto yy191;
yy337:
		YYDEBUG(337, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy338;
		if (yych != 'c') goto yy191;
yy338:
		YYDEBUG(338, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy339;
		if (yych != 'e') goto yy191;
yy339:
		YYDEBUG(339, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(340, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(341, *YYCURSOR);
		yyaccept = 16;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy342;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy342:
		YYDEBUG(342, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_NS_C);
}
yy343:
		YYDEBUG(343, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy344;
		if (yych != 'r') goto yy191;
yy344:
		YYDEBUG(344, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(345, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(346, *YYCURSOR);
		yyaccept = 17;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy347;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy347:
		YYDEBUG(347, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_DIR);
}
yy348:
		YYDEBUG(348, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy349;
		if (yych != 'n') goto yy191;
yy349:
		YYDEBUG(349, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy350;
		if (yych != 'e') goto yy191;
yy350:
		YYDEBUG(350, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(351, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(352, *YYCURSOR);
		yyaccept = 18;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy353;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy353:
		YYDEBUG(353, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_LINE);
}
yy354:
		YYDEBUG(354, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy355;
		if (yych != 't') goto yy191;
yy355:
		YYDEBUG(355, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy356;
		if (yych != 'h') goto yy191;
yy356:
		YYDEBUG(356, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy357;
		if (yych != 'o') goto yy191;
yy357:
		YYDEBUG(357, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy358;
		if (yych != 'd') goto yy191;
yy358:
		YYDEBUG(358, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(359, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(360, *YYCURSOR);
		yyaccept = 19;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy361;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy361:
		YYDEBUG(361, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_METHOD_C);
}
yy362:
		YYDEBUG(362, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy373;
		if (yych == 'l') goto yy373;
		goto yy191;
yy363:
		YYDEBUG(363, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy364;
		if (yych != 'n') goto yy191;
yy364:
		YYDEBUG(364, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy365;
		if (yych != 'c') goto yy191;
yy365:
		YYDEBUG(365, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy366;
		if (yych != 't') goto yy191;
yy366:
		YYDEBUG(366, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy367;
		if (yych != 'i') goto yy191;
yy367:
		YYDEBUG(367, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy368;
		if (yych != 'o') goto yy191;
yy368:
		YYDEBUG(368, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy369;
		if (yych != 'n') goto yy191;
yy369:
		YYDEBUG(369, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(370, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(371, *YYCURSOR);
		yyaccept = 20;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy372;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy372:
		YYDEBUG(372, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_FUNC_C);
}
yy373:
		YYDEBUG(373, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy374;
		if (yych != 'e') goto yy191;
yy374:
		YYDEBUG(374, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(375, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(376, *YYCURSOR);
		yyaccept = 21;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy377;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy377:
		YYDEBUG(377, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_FILE);
}
yy378:
		YYDEBUG(378, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy379;
		if (yych != 'a') goto yy191;
yy379:
		YYDEBUG(379, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy380;
		if (yych != 'i') goto yy191;
yy380:
		YYDEBUG(380, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy381;
		if (yych != 't') goto yy191;
yy381:
		YYDEBUG(381, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(382, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(383, *YYCURSOR);
		yyaccept = 22;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy384;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy384:
		YYDEBUG(384, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_TRAIT_C);
}
yy385:
		YYDEBUG(385, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy386;
		if (yych != 'a') goto yy191;
yy386:
		YYDEBUG(386, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy387;
		if (yych != 's') goto yy191;
yy387:
		YYDEBUG(387, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy388;
		if (yych != 's') goto yy191;
yy388:
		YYDEBUG(388, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(389, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(390, *YYCURSOR);
		yyaccept = 23;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy391;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy391:
		YYDEBUG(391, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_CLASS_C);
}
yy392:
		YYDEBUG(392, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy393;
		if (yych != 'l') goto yy191;
yy393:
		YYDEBUG(393, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy394;
		if (yych != 't') goto yy191;
yy394:
		YYDEBUG(394, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy191;
		YYDEBUG(395, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy396;
		if (yych != 'c') goto yy191;
yy396:
		YYDEBUG(396, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy397;
		if (yych != 'o') goto yy191;
yy397:
		YYDEBUG(397, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy398;
		if (yych != 'm') goto yy191;
yy398:
		YYDEBUG(398, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'P') goto yy399;
		if (yych != 'p') goto yy191;
yy399:
		YYDEBUG(399, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy400;
		if (yych != 'i') goto yy191;
yy400:
		YYDEBUG(400, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy401;
		if (yych != 'l') goto yy191;
yy401:
		YYDEBUG(401, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy402;
		if (yych != 'e') goto yy191;
yy402:
		YYDEBUG(402, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy403;
		if (yych != 'r') goto yy191;
yy403:
		YYDEBUG(403, *YYCURSOR);
		yyaccept = 24;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy404;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy404:
		YYDEBUG(404, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_HALT_COMPILER);
}
yy405:
		YYDEBUG(405, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy409;
		if (yych == 's') goto yy409;
		goto yy191;
yy406:
		YYDEBUG(406, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy407;
		if (yych != 'e') goto yy191;
yy407:
		YYDEBUG(407, *YYCURSOR);
		yyaccept = 25;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy408;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy408:
		YYDEBUG(408, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_USE);
}
yy409:
		YYDEBUG(409, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy410;
		if (yych != 'e') goto yy191;
yy410:
		YYDEBUG(410, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy411;
		if (yych != 't') goto yy191;
yy411:
		YYDEBUG(411, *YYCURSOR);
		yyaccept = 26;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy412;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy412:
		YYDEBUG(412, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_UNSET);
}
yy413:
		YYDEBUG(413, *YYCURSOR);
		++YYCURSOR;
		YYFILL(7);
		yych = *YYCURSOR;
yy414:
		YYDEBUG(414, *YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'D') {
				if (yych <= ' ') {
					if (yych == '\t') goto yy413;
					if (yych <= 0x1F) goto yy187;
					goto yy413;
				} else {
					if (yych <= 'A') {
						if (yych <= '@') goto yy187;
						goto yy418;
					} else {
						if (yych <= 'B') goto yy416;
						if (yych <= 'C') goto yy187;
						goto yy421;
					}
				}
			} else {
				if (yych <= 'I') {
					if (yych == 'F') goto yy422;
					if (yych <= 'H') goto yy187;
					goto yy423;
				} else {
					if (yych <= 'O') {
						if (yych <= 'N') goto yy187;
						goto yy417;
					} else {
						if (yych <= 'Q') goto yy187;
						if (yych <= 'R') goto yy420;
						goto yy419;
					}
				}
			}
		} else {
			if (yych <= 'f') {
				if (yych <= 'a') {
					if (yych == 'U') goto yy415;
					if (yych <= '`') goto yy187;
					goto yy418;
				} else {
					if (yych <= 'c') {
						if (yych <= 'b') goto yy416;
						goto yy187;
					} else {
						if (yych <= 'd') goto yy421;
						if (yych <= 'e') goto yy187;
						goto yy422;
					}
				}
			} else {
				if (yych <= 'q') {
					if (yych <= 'i') {
						if (yych <= 'h') goto yy187;
						goto yy423;
					} else {
						if (yych == 'o') goto yy417;
						goto yy187;
					}
				} else {
					if (yych <= 's') {
						if (yych <= 'r') goto yy420;
						goto yy419;
					} else {
						if (yych != 'u') goto yy187;
					}
				}
			}
		}
yy415:
		YYDEBUG(415, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy486;
		if (yych == 'n') goto yy486;
		goto yy187;
yy416:
		YYDEBUG(416, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych == 'I') goto yy473;
			if (yych <= 'N') goto yy187;
			goto yy474;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy187;
				goto yy473;
			} else {
				if (yych == 'o') goto yy474;
				goto yy187;
			}
		}
yy417:
		YYDEBUG(417, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy465;
		if (yych == 'b') goto yy465;
		goto yy187;
yy418:
		YYDEBUG(418, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy458;
		if (yych == 'r') goto yy458;
		goto yy187;
yy419:
		YYDEBUG(419, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy450;
		if (yych == 't') goto yy450;
		goto yy187;
yy420:
		YYDEBUG(420, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy444;
		if (yych == 'e') goto yy444;
		goto yy187;
yy421:
		YYDEBUG(421, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy440;
		if (yych == 'o') goto yy440;
		goto yy187;
yy422:
		YYDEBUG(422, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy433;
		if (yych == 'l') goto yy433;
		goto yy187;
yy423:
		YYDEBUG(423, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy424;
		if (yych != 'n') goto yy187;
yy424:
		YYDEBUG(424, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy425;
		if (yych != 't') goto yy187;
yy425:
		YYDEBUG(425, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy426;
		if (yych != 'e') goto yy428;
yy426:
		YYDEBUG(426, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy431;
		if (yych == 'g') goto yy431;
		goto yy187;
yy427:
		YYDEBUG(427, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy428:
		YYDEBUG(428, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy427;
			goto yy187;
		} else {
			if (yych <= ' ') goto yy427;
			if (yych != ')') goto yy187;
		}
		YYDEBUG(429, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(430, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_INT_CAST);
}
yy431:
		YYDEBUG(431, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy432;
		if (yych != 'e') goto yy187;
yy432:
		YYDEBUG(432, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy427;
		if (yych == 'r') goto yy427;
		goto yy187;
yy433:
		YYDEBUG(433, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy434;
		if (yych != 'o') goto yy187;
yy434:
		YYDEBUG(434, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy435;
		if (yych != 'a') goto yy187;
yy435:
		YYDEBUG(435, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy436;
		if (yych != 't') goto yy187;
yy436:
		YYDEBUG(436, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(437, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy436;
			goto yy187;
		} else {
			if (yych <= ' ') goto yy436;
			if (yych != ')') goto yy187;
		}
		YYDEBUG(438, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(439, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_DOUBLE_CAST);
}
yy440:
		YYDEBUG(440, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy441;
		if (yych != 'u') goto yy187;
yy441:
		YYDEBUG(441, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy442;
		if (yych != 'b') goto yy187;
yy442:
		YYDEBUG(442, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy443;
		if (yych != 'l') goto yy187;
yy443:
		YYDEBUG(443, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy436;
		if (yych == 'e') goto yy436;
		goto yy187;
yy444:
		YYDEBUG(444, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy445;
		if (yych != 'a') goto yy187;
yy445:
		YYDEBUG(445, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy446;
		if (yych != 'l') goto yy187;
yy446:
		YYDEBUG(446, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(447, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy446;
			goto yy187;
		} else {
			if (yych <= ' ') goto yy446;
			if (yych != ')') goto yy187;
		}
		YYDEBUG(448, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(449, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	if (PARSER_MODE()) {
		zend_throw_exception(zend_ce_parse_error, "The (real) cast has been removed, use (float) instead", 0);
		RETURN_TOKEN(T_ERROR);
	}
	RETURN_TOKEN(T_DOUBLE_CAST);
}
yy450:
		YYDEBUG(450, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy451;
		if (yych != 'r') goto yy187;
yy451:
		YYDEBUG(451, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy452;
		if (yych != 'i') goto yy187;
yy452:
		YYDEBUG(452, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy453;
		if (yych != 'n') goto yy187;
yy453:
		YYDEBUG(453, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy454;
		if (yych != 'g') goto yy187;
yy454:
		YYDEBUG(454, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(455, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy454;
			goto yy187;
		} else {
			if (yych <= ' ') goto yy454;
			if (yych != ')') goto yy187;
		}
		YYDEBUG(456, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(457, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_STRING_CAST);
}
yy458:
		YYDEBUG(458, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy459;
		if (yych != 'r') goto yy187;
yy459:
		YYDEBUG(459, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy460;
		if (yych != 'a') goto yy187;
yy460:
		YYDEBUG(460, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy461;
		if (yych != 'y') goto yy187;
yy461:
		YYDEBUG(461, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(462, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy461;
			goto yy187;
		} else {
			if (yych <= ' ') goto yy461;
			if (yych != ')') goto yy187;
		}
		YYDEBUG(463, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(464, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_ARRAY_CAST);
}
yy465:
		YYDEBUG(465, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'J') goto yy466;
		if (yych != 'j') goto yy187;
yy466:
		YYDEBUG(466, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy467;
		if (yych != 'e') goto yy187;
yy467:
		YYDEBUG(467, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy468;
		if (yych != 'c') goto yy187;
yy468:
		YYDEBUG(468, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy469;
		if (yych != 't') goto yy187;
yy469:
		YYDEBUG(469, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(470, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy469;
			goto yy187;
		} else {
			if (yych <= ' ') goto yy469;
			if (yych != ')') goto yy187;
		}
		YYDEBUG(471, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(472, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_OBJECT_CAST);
}
yy473:
		YYDEBUG(473, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy483;
		if (yych == 'n') goto yy483;
		goto yy187;
yy474:
		YYDEBUG(474, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy475;
		if (yych != 'o') goto yy187;
yy475:
		YYDEBUG(475, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy476;
		if (yych != 'l') goto yy187;
yy476:
		YYDEBUG(476, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy481;
		if (yych == 'e') goto yy481;
		goto yy478;
yy477:
		YYDEBUG(477, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy478:
		YYDEBUG(478, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy477;
			goto yy187;
		} else {
			if (yych <= ' ') goto yy477;
			if (yych != ')') goto yy187;
		}
		YYDEBUG(479, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(480, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_BOOL_CAST);
}
yy481:
		YYDEBUG(481, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy482;
		if (yych != 'a') goto yy187;
yy482:
		YYDEBUG(482, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy477;
		if (yych == 'n') goto yy477;
		goto yy187;
yy483:
		YYDEBUG(483, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy484;
		if (yych != 'a') goto yy187;
yy484:
		YYDEBUG(484, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy485;
		if (yych != 'r') goto yy187;
yy485:
		YYDEBUG(485, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy454;
		if (yych == 'y') goto yy454;
		goto yy187;
yy486:
		YYDEBUG(486, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy487;
		if (yych != 's') goto yy187;
yy487:
		YYDEBUG(487, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy488;
		if (yych != 'e') goto yy187;
yy488:
		YYDEBUG(488, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy489;
		if (yych != 't') goto yy187;
yy489:
		YYDEBUG(489, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(490, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy489;
			goto yy187;
		} else {
			if (yych <= ' ') goto yy489;
			if (yych != ')') goto yy187;
		}
		YYDEBUG(491, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(492, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_UNSET_CAST);
}
yy493:
		YYDEBUG(493, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy494;
		if (yych != 'r') goto yy191;
yy494:
		YYDEBUG(494, *YYCURSOR);
		yyaccept = 27;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy495;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy495:
		YYDEBUG(495, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_VAR);
}
yy496:
		YYDEBUG(496, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy500;
		if (yych == 'm') goto yy500;
		goto yy191;
yy497:
		YYDEBUG(497, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'W') goto yy498;
		if (yych != 'w') goto yy191;
yy498:
		YYDEBUG(498, *YYCURSOR);
		yyaccept = 28;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy499;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy499:
		YYDEBUG(499, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_NEW);
}
yy500:
		YYDEBUG(500, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy501;
		if (yych != 'e') goto yy191;
yy501:
		YYDEBUG(501, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy502;
		if (yych != 's') goto yy191;
yy502:
		YYDEBUG(502, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'P') goto yy503;
		if (yych != 'p') goto yy191;
yy503:
		YYDEBUG(503, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy504;
		if (yych != 'a') goto yy191;
yy504:
		YYDEBUG(504, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy505;
		if (yych != 'c') goto yy191;
yy505:
		YYDEBUG(505, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy506;
		if (yych != 'e') goto yy191;
yy506:
		YYDEBUG(506, *YYCURSOR);
		yyaccept = 29;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy507;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy508;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy507:
		YYDEBUG(507, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_NAMESPACE);
}
yy508:
		YYDEBUG(508, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy187;
			if (yych <= 'Z') goto yy509;
			if (yych <= '^') goto yy187;
		} else {
			if (yych <= '`') goto yy187;
			if (yych <= 'z') goto yy509;
			if (yych <= 0x7F) goto yy187;
		}
yy509:
		YYDEBUG(509, *YYCURSOR);
		yyaccept = 30;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(510, *YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy511;
				if (yych <= '9') goto yy509;
			} else {
				if (yych <= 'Z') goto yy509;
				if (yych >= '\\') goto yy508;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy509;
			} else {
				if (yych <= 'z') goto yy509;
				if (yych >= 0x80) goto yy509;
			}
		}
yy511:
		YYDEBUG(511, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_NAME_RELATIVE, sizeof("namespace\\") - 1);
}
yy512:
		YYDEBUG(512, *YYCURSOR);
		yyaccept = 7;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(513, *YYCURSOR);
		if (yych <= 'E') {
			if (yych <= '/') goto yy198;
			if (yych <= '9') goto yy512;
			if (yych <= 'D') goto yy198;
			goto yy201;
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy198;
				goto yy519;
			} else {
				if (yych == 'e') goto yy201;
				goto yy198;
			}
		}
yy514:
		YYDEBUG(514, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(515, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_CONCAT_EQUAL);
}
yy516:
		YYDEBUG(516, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '.') goto yy187;
		YYDEBUG(517, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(518, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_ELLIPSIS);
}
yy519:
		YYDEBUG(519, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy187;
		if (yych >= ':') goto yy187;
yy520:
		YYDEBUG(520, *YYCURSOR);
		yyaccept = 7;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(521, *YYCURSOR);
		if (yych <= 'E') {
			if (yych <= '/') goto yy198;
			if (yych <= '9') goto yy520;
			if (yych <= 'D') goto yy198;
			goto yy201;
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy198;
				goto yy519;
			} else {
				if (yych == 'e') goto yy201;
				goto yy198;
			}
		}
yy522:
		YYDEBUG(522, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(523, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_PAAMAYIM_NEKUDOTAYIM);
}
yy524:
		YYDEBUG(524, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy525:
		YYDEBUG(525, *YYCURSOR);
		if (yych <= '\f') {
			if (yych <= 0x08) goto yy136;
			if (yych <= '\n') goto yy524;
			goto yy136;
		} else {
			if (yych <= '\r') goto yy524;
			if (yych == ' ') goto yy524;
			goto yy136;
		}
yy526:
		YYDEBUG(526, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '\n') goto yy535;
		if (yych == '\r') goto yy536;
yy527:
		YYDEBUG(527, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	BEGIN(INITIAL);
	if (yytext[yyleng-1] != '>') {
		CG(increment_lineno) = 1;
	}
	if (PARSER_MODE()) {
		RETURN_TOKEN(';');  /* implicit ';' at php-end tag */
	}
	RETURN_TOKEN(T_CLOSE_TAG);
}
yy528:
		YYDEBUG(528, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy533;
		YYDEBUG(529, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_COALESCE);
}
yy530:
		YYDEBUG(530, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '>') goto yy187;
		YYDEBUG(531, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(532, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN(T_NULLSAFE_OBJECT_OPERATOR);
}
yy533:
		YYDEBUG(533, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(534, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_COALESCE_EQUAL);
}
yy535:
		YYDEBUG(535, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy527;
yy536:
		YYDEBUG(536, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy535;
		goto yy527;
yy537:
		YYDEBUG(537, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(538, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_MINUS_EQUAL);
}
yy539:
		YYDEBUG(539, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(540, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_DEC);
}
yy541:
		YYDEBUG(541, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(542, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN(T_OBJECT_OPERATOR);
}
yy543:
		YYDEBUG(543, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych == 'I') goto yy550;
			if (yych <= 'N') goto yy191;
			goto yy551;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy191;
				goto yy550;
			} else {
				if (yych == 'o') goto yy551;
				goto yy191;
			}
		}
yy544:
		YYDEBUG(544, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'B') goto yy545;
		if (yych != 'b') goto yy191;
yy545:
		YYDEBUG(545, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy546;
		if (yych != 'l') goto yy191;
yy546:
		YYDEBUG(546, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy547;
		if (yych != 'i') goto yy191;
yy547:
		YYDEBUG(547, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy548;
		if (yych != 'c') goto yy191;
yy548:
		YYDEBUG(548, *YYCURSOR);
		yyaccept = 31;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy549;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy549:
		YYDEBUG(549, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_PUBLIC);
}
yy550:
		YYDEBUG(550, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'V') {
			if (yych == 'N') goto yy559;
			if (yych <= 'U') goto yy191;
			goto yy560;
		} else {
			if (yych <= 'n') {
				if (yych <= 'm') goto yy191;
				goto yy559;
			} else {
				if (yych == 'v') goto yy560;
				goto yy191;
			}
		}
yy551:
		YYDEBUG(551, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy552;
		if (yych != 't') goto yy191;
yy552:
		YYDEBUG(552, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy553;
		if (yych != 'e') goto yy191;
yy553:
		YYDEBUG(553, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy554;
		if (yych != 'c') goto yy191;
yy554:
		YYDEBUG(554, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy555;
		if (yych != 't') goto yy191;
yy555:
		YYDEBUG(555, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy556;
		if (yych != 'e') goto yy191;
yy556:
		YYDEBUG(556, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy557;
		if (yych != 'd') goto yy191;
yy557:
		YYDEBUG(557, *YYCURSOR);
		yyaccept = 32;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy558;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy558:
		YYDEBUG(558, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_PROTECTED);
}
yy559:
		YYDEBUG(559, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy565;
		if (yych == 't') goto yy565;
		goto yy191;
yy560:
		YYDEBUG(560, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy561;
		if (yych != 'a') goto yy191;
yy561:
		YYDEBUG(561, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy562;
		if (yych != 't') goto yy191;
yy562:
		YYDEBUG(562, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy563;
		if (yych != 'e') goto yy191;
yy563:
		YYDEBUG(563, *YYCURSOR);
		yyaccept = 33;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy564;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy564:
		YYDEBUG(564, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_PRIVATE);
}
yy565:
		YYDEBUG(565, *YYCURSOR);
		yyaccept = 34;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy566;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy566:
		YYDEBUG(566, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_PRINT);
}
yy567:
		YYDEBUG(567, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy572;
		if (yych == 'o') goto yy572;
		goto yy191;
yy568:
		YYDEBUG(568, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy569;
		if (yych != 't') goto yy191;
yy569:
		YYDEBUG(569, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy570;
		if (yych != 'o') goto yy191;
yy570:
		YYDEBUG(570, *YYCURSOR);
		yyaccept = 35;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy571;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy571:
		YYDEBUG(571, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_GOTO);
}
yy572:
		YYDEBUG(572, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'B') goto yy573;
		if (yych != 'b') goto yy191;
yy573:
		YYDEBUG(573, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy574;
		if (yych != 'a') goto yy191;
yy574:
		YYDEBUG(574, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy575;
		if (yych != 'l') goto yy191;
yy575:
		YYDEBUG(575, *YYCURSOR);
		yyaccept = 36;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy576;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy576:
		YYDEBUG(576, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_GLOBAL);
}
yy577:
		YYDEBUG(577, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '<') goto yy585;
		goto yy187;
yy578:
		YYDEBUG(578, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy178;
yy579:
		YYDEBUG(579, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy176;
yy580:
		YYDEBUG(580, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy581;
		if (yych != 'e') goto yy191;
yy581:
		YYDEBUG(581, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy582;
		if (yych != 'a') goto yy191;
yy582:
		YYDEBUG(582, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'K') goto yy583;
		if (yych != 'k') goto yy191;
yy583:
		YYDEBUG(583, *YYCURSOR);
		yyaccept = 37;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy584;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy584:
		YYDEBUG(584, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_BREAK);
}
yy585:
		YYDEBUG(585, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '<') goto yy292;
		goto yy187;
yy586:
		YYDEBUG(586, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy587;
		if (yych != 't') goto yy191;
yy587:
		YYDEBUG(587, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy588;
		if (yych != 'c') goto yy191;
yy588:
		YYDEBUG(588, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy589;
		if (yych != 'h') goto yy191;
yy589:
		YYDEBUG(589, *YYCURSOR);
		yyaccept = 38;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy590;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy590:
		YYDEBUG(590, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_MATCH);
}
yy591:
		YYDEBUG(591, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy598;
		if (yych == 'a') goto yy598;
		goto yy191;
yy592:
		YYDEBUG(592, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy593;
		if (yych != 'i') goto yy191;
yy593:
		YYDEBUG(593, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy594;
		if (yych != 't') goto yy191;
yy594:
		YYDEBUG(594, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy595;
		if (yych != 'c') goto yy191;
yy595:
		YYDEBUG(595, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy596;
		if (yych != 'h') goto yy191;
yy596:
		YYDEBUG(596, *YYCURSOR);
		yyaccept = 39;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy597;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy597:
		YYDEBUG(597, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_SWITCH);
}
yy598:
		YYDEBUG(598, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy599;
		if (yych != 't') goto yy191;
yy599:
		YYDEBUG(599, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy600;
		if (yych != 'i') goto yy191;
yy600:
		YYDEBUG(600, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy601;
		if (yych != 'c') goto yy191;
yy601:
		YYDEBUG(601, *YYCURSOR);
		yyaccept = 40;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy602;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy602:
		YYDEBUG(602, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_STATIC);
}
yy603:
		YYDEBUG(603, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy614;
		if (yych == 's') goto yy614;
		goto yy191;
yy604:
		YYDEBUG(604, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy612;
		if (yych == 'd') goto yy612;
		goto yy191;
yy605:
		YYDEBUG(605, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy608;
		if (yych == 'r') goto yy608;
		goto yy191;
yy606:
		YYDEBUG(606, *YYCURSOR);
		yyaccept = 41;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy607;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy607:
		YYDEBUG(607, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_AS);
}
yy608:
		YYDEBUG(608, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy609;
		if (yych != 'a') goto yy191;
yy609:
		YYDEBUG(609, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'Y') goto yy610;
		if (yych != 'y') goto yy191;
yy610:
		YYDEBUG(610, *YYCURSOR);
		yyaccept = 42;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy611;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy611:
		YYDEBUG(611, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ARRAY);
}
yy612:
		YYDEBUG(612, *YYCURSOR);
		yyaccept = 43;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy613;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy613:
		YYDEBUG(613, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_LOGICAL_AND);
}
yy614:
		YYDEBUG(614, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy615;
		if (yych != 't') goto yy191;
yy615:
		YYDEBUG(615, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy616;
		if (yych != 'r') goto yy191;
yy616:
		YYDEBUG(616, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy617;
		if (yych != 'a') goto yy191;
yy617:
		YYDEBUG(617, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy618;
		if (yych != 'c') goto yy191;
yy618:
		YYDEBUG(618, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy619;
		if (yych != 't') goto yy191;
yy619:
		YYDEBUG(619, *YYCURSOR);
		yyaccept = 44;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy620;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy620:
		YYDEBUG(620, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ABSTRACT);
}
yy621:
		YYDEBUG(621, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy622;
		if (yych != 'i') goto yy191;
yy622:
		YYDEBUG(622, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy623;
		if (yych != 'l') goto yy191;
yy623:
		YYDEBUG(623, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy624;
		if (yych != 'e') goto yy191;
yy624:
		YYDEBUG(624, *YYCURSOR);
		yyaccept = 45;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy625;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy625:
		YYDEBUG(625, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_WHILE);
}
yy626:
		YYDEBUG(626, *YYCURSOR);
		yyaccept = 46;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy627;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy627:
		YYDEBUG(627, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_IF);
}
yy628:
		YYDEBUG(628, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'P') goto yy670;
		if (yych == 'p') goto yy670;
		goto yy191;
yy629:
		YYDEBUG(629, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'T') {
			if (yych <= 'C') {
				if (yych <= 'B') goto yy191;
				goto yy637;
			} else {
				if (yych <= 'R') goto yy191;
				if (yych <= 'S') goto yy635;
				goto yy636;
			}
		} else {
			if (yych <= 'r') {
				if (yych == 'c') goto yy637;
				goto yy191;
			} else {
				if (yych <= 's') goto yy635;
				if (yych <= 't') goto yy636;
				goto yy191;
			}
		}
yy630:
		YYDEBUG(630, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy631;
		if (yych != 's') goto yy191;
yy631:
		YYDEBUG(631, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy632;
		if (yych != 'e') goto yy191;
yy632:
		YYDEBUG(632, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy633;
		if (yych != 't') goto yy191;
yy633:
		YYDEBUG(633, *YYCURSOR);
		yyaccept = 47;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy634;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy634:
		YYDEBUG(634, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ISSET);
}
yy635:
		YYDEBUG(635, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy656;
		if (yych == 't') goto yy656;
		goto yy191;
yy636:
		YYDEBUG(636, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy649;
		if (yych == 'e') goto yy649;
		goto yy191;
yy637:
		YYDEBUG(637, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy638;
		if (yych != 'l') goto yy191;
yy638:
		YYDEBUG(638, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'U') goto yy639;
		if (yych != 'u') goto yy191;
yy639:
		YYDEBUG(639, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy640;
		if (yych != 'd') goto yy191;
yy640:
		YYDEBUG(640, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy641;
		if (yych != 'e') goto yy191;
yy641:
		YYDEBUG(641, *YYCURSOR);
		yyaccept = 48;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy642;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy643;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy642:
		YYDEBUG(642, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_INCLUDE);
}
yy643:
		YYDEBUG(643, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy644;
		if (yych != 'o') goto yy191;
yy644:
		YYDEBUG(644, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy645;
		if (yych != 'n') goto yy191;
yy645:
		YYDEBUG(645, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy646;
		if (yych != 'c') goto yy191;
yy646:
		YYDEBUG(646, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy647;
		if (yych != 'e') goto yy191;
yy647:
		YYDEBUG(647, *YYCURSOR);
		yyaccept = 49;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy648;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy648:
		YYDEBUG(648, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_INCLUDE_ONCE);
}
yy649:
		YYDEBUG(649, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy650;
		if (yych != 'r') goto yy191;
yy650:
		YYDEBUG(650, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'F') goto yy651;
		if (yych != 'f') goto yy191;
yy651:
		YYDEBUG(651, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy652;
		if (yych != 'a') goto yy191;
yy652:
		YYDEBUG(652, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy653;
		if (yych != 'c') goto yy191;
yy653:
		YYDEBUG(653, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy654;
		if (yych != 'e') goto yy191;
yy654:
		YYDEBUG(654, *YYCURSOR);
		yyaccept = 50;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy655;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy655:
		YYDEBUG(655, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_INTERFACE);
}
yy656:
		YYDEBUG(656, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'E') {
			if (yych == 'A') goto yy657;
			if (yych <= 'D') goto yy191;
			goto yy658;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy191;
			} else {
				if (yych == 'e') goto yy658;
				goto yy191;
			}
		}
yy657:
		YYDEBUG(657, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy664;
		if (yych == 'n') goto yy664;
		goto yy191;
yy658:
		YYDEBUG(658, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy659;
		if (yych != 'a') goto yy191;
yy659:
		YYDEBUG(659, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy660;
		if (yych != 'd') goto yy191;
yy660:
		YYDEBUG(660, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy661;
		if (yych != 'o') goto yy191;
yy661:
		YYDEBUG(661, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'F') goto yy662;
		if (yych != 'f') goto yy191;
yy662:
		YYDEBUG(662, *YYCURSOR);
		yyaccept = 51;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy663;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy663:
		YYDEBUG(663, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
    RETURN_TOKEN_WITH_IDENT(T_INSTEADOF);
}
yy664:
		YYDEBUG(664, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy665;
		if (yych != 'c') goto yy191;
yy665:
		YYDEBUG(665, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy666;
		if (yych != 'e') goto yy191;
yy666:
		YYDEBUG(666, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy667;
		if (yych != 'o') goto yy191;
yy667:
		YYDEBUG(667, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'F') goto yy668;
		if (yych != 'f') goto yy191;
yy668:
		YYDEBUG(668, *YYCURSOR);
		yyaccept = 52;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy669;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy669:
		YYDEBUG(669, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_INSTANCEOF);
}
yy670:
		YYDEBUG(670, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy671;
		if (yych != 'l') goto yy191;
yy671:
		YYDEBUG(671, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy672;
		if (yych != 'e') goto yy191;
yy672:
		YYDEBUG(672, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy673;
		if (yych != 'm') goto yy191;
yy673:
		YYDEBUG(673, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy674;
		if (yych != 'e') goto yy191;
yy674:
		YYDEBUG(674, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy675;
		if (yych != 'n') goto yy191;
yy675:
		YYDEBUG(675, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy676;
		if (yych != 't') goto yy191;
yy676:
		YYDEBUG(676, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy677;
		if (yych != 's') goto yy191;
yy677:
		YYDEBUG(677, *YYCURSOR);
		yyaccept = 53;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy678;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy678:
		YYDEBUG(678, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_IMPLEMENTS);
}
yy679:
		YYDEBUG(679, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy687;
		if (yych == 'r') goto yy687;
		goto yy191;
yy680:
		YYDEBUG(680, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'Y') {
			if (yych == 'A') goto yy683;
			if (yych <= 'X') goto yy191;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy191;
				goto yy683;
			} else {
				if (yych != 'y') goto yy191;
			}
		}
		YYDEBUG(681, *YYCURSOR);
		yyaccept = 54;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy682;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy682:
		YYDEBUG(682, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_TRY);
}
yy683:
		YYDEBUG(683, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy684;
		if (yych != 'i') goto yy191;
yy684:
		YYDEBUG(684, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy685;
		if (yych != 't') goto yy191;
yy685:
		YYDEBUG(685, *YYCURSOR);
		yyaccept = 55;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy686;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy686:
		YYDEBUG(686, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_TRAIT);
}
yy687:
		YYDEBUG(687, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy688;
		if (yych != 'o') goto yy191;
yy688:
		YYDEBUG(688, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'W') goto yy689;
		if (yych != 'w') goto yy191;
yy689:
		YYDEBUG(689, *YYCURSOR);
		yyaccept = 56;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy690;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy690:
		YYDEBUG(690, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_THROW);
}
yy691:
		YYDEBUG(691, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy692;
		if (yych != 'e') goto yy191;
yy692:
		YYDEBUG(692, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy693;
		if (yych != 'l') goto yy191;
yy693:
		YYDEBUG(693, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy694;
		if (yych != 'd') goto yy191;
yy694:
		YYDEBUG(694, *YYCURSOR);
		yyaccept = 57;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '@') {
			if (yych <= '\r') {
				if (yych <= 0x08) goto yy695;
				if (yych <= '\n') goto yy696;
				if (yych >= '\r') goto yy696;
			} else {
				if (yych <= ' ') {
					if (yych >= ' ') goto yy696;
				} else {
					if (yych <= '/') goto yy695;
					if (yych <= '9') goto yy190;
				}
			}
		} else {
			if (yych <= '^') {
				if (yych <= 'Z') goto yy190;
				if (yych == '\\') goto yy192;
			} else {
				if (yych <= '`') {
					if (yych <= '_') goto yy190;
				} else {
					if (yych <= 'z') goto yy190;
					if (yych >= 0x80) goto yy190;
				}
			}
		}
yy695:
		YYDEBUG(695, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_YIELD);
}
yy696:
		YYDEBUG(696, *YYCURSOR);
		++YYCURSOR;
		YYFILL(5);
		yych = *YYCURSOR;
		YYDEBUG(697, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy187;
				goto yy696;
			} else {
				if (yych == '\r') goto yy696;
				goto yy187;
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ' ') goto yy696;
				if (yych <= 'E') goto yy187;
			} else {
				if (yych != 'f') goto yy187;
			}
		}
		YYDEBUG(698, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy699;
		if (yych != 'r') goto yy187;
yy699:
		YYDEBUG(699, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy700;
		if (yych != 'o') goto yy187;
yy700:
		YYDEBUG(700, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy701;
		if (yych != 'm') goto yy187;
yy701:
		YYDEBUG(701, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy187;
			} else {
				if (yych <= '@') goto yy702;
				if (yych <= 'Z') goto yy187;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy187;
			} else {
				if (yych <= 'z') goto yy187;
				if (yych >= 0x80) goto yy187;
			}
		}
yy702:
		YYDEBUG(702, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(703, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 1);
	HANDLE_NEWLINES(yytext, yyleng);
	RETURN_TOKEN_WITH_IDENT(T_YIELD_FROM);
}
yy704:
		YYDEBUG(704, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(705, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	enter_nesting('[');
	RETURN_TOKEN(T_ATTRIBUTE);
}
yy706:
		YYDEBUG(706, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'T') {
			if (yych <= 'P') {
				if (yych == 'A') goto yy709;
				goto yy191;
			} else {
				if (yych <= 'Q') goto yy708;
				if (yych <= 'S') goto yy191;
			}
		} else {
			if (yych <= 'p') {
				if (yych == 'a') goto yy709;
				goto yy191;
			} else {
				if (yych <= 'q') goto yy708;
				if (yych != 't') goto yy191;
			}
		}
		YYDEBUG(707, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'U') goto yy731;
		if (yych == 'u') goto yy731;
		goto yy191;
yy708:
		YYDEBUG(708, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'U') goto yy720;
		if (yych == 'u') goto yy720;
		goto yy191;
yy709:
		YYDEBUG(709, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy710;
		if (yych != 'd') goto yy191;
yy710:
		YYDEBUG(710, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy711;
		if (yych != 'o') goto yy191;
yy711:
		YYDEBUG(711, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy712;
		if (yych != 'n') goto yy191;
yy712:
		YYDEBUG(712, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy713;
		if (yych != 'l') goto yy191;
yy713:
		YYDEBUG(713, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'Y') goto yy714;
		if (yych != 'y') goto yy191;
yy714:
		YYDEBUG(714, *YYCURSOR);
		yyaccept = 58;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '9') {
			if (yych <= 0x1F) {
				if (yych <= '\n') {
					if (yych >= '\t') goto yy716;
				} else {
					if (yych == '\r') goto yy716;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= ' ') goto yy716;
				} else {
					if (yych <= '(') goto yy718;
					if (yych >= '0') goto yy190;
				}
			}
		} else {
			if (yych <= '^') {
				if (yych <= 'Z') {
					if (yych >= 'A') goto yy190;
				} else {
					if (yych == '\\') goto yy192;
				}
			} else {
				if (yych <= '`') {
					if (yych <= '_') goto yy190;
				} else {
					if (yych <= 'z') goto yy190;
					if (yych >= 0x80) goto yy190;
				}
			}
		}
yy715:
		YYDEBUG(715, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_READONLY);
}
yy716:
		YYDEBUG(716, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(717, *YYCURSOR);
		if (yych <= '\r') {
			if (yych <= 0x08) goto yy187;
			if (yych <= '\n') goto yy716;
			if (yych <= '\f') goto yy187;
			goto yy716;
		} else {
			if (yych <= ' ') {
				if (yych <= 0x1F) goto yy187;
				goto yy716;
			} else {
				if (yych != '(') goto yy187;
			}
		}
yy718:
		YYDEBUG(718, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(719, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(strlen("readonly"));
	RETURN_TOKEN_WITH_STR(T_STRING, 0);
}
yy720:
		YYDEBUG(720, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy721;
		if (yych != 'i') goto yy191;
yy721:
		YYDEBUG(721, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy722;
		if (yych != 'r') goto yy191;
yy722:
		YYDEBUG(722, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy723;
		if (yych != 'e') goto yy191;
yy723:
		YYDEBUG(723, *YYCURSOR);
		yyaccept = 59;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy724;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy725;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy724:
		YYDEBUG(724, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_REQUIRE);
}
yy725:
		YYDEBUG(725, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy726;
		if (yych != 'o') goto yy191;
yy726:
		YYDEBUG(726, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy727;
		if (yych != 'n') goto yy191;
yy727:
		YYDEBUG(727, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy728;
		if (yych != 'c') goto yy191;
yy728:
		YYDEBUG(728, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy729;
		if (yych != 'e') goto yy191;
yy729:
		YYDEBUG(729, *YYCURSOR);
		yyaccept = 60;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy730;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy730:
		YYDEBUG(730, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_REQUIRE_ONCE);
}
yy731:
		YYDEBUG(731, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy732;
		if (yych != 'r') goto yy191;
yy732:
		YYDEBUG(732, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy733;
		if (yych != 'n') goto yy191;
yy733:
		YYDEBUG(733, *YYCURSOR);
		yyaccept = 61;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy734;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy734:
		YYDEBUG(734, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_RETURN);
}
yy735:
		YYDEBUG(735, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'T') {
			if (yych <= 'L') {
				if (yych <= 'K') goto yy191;
				goto yy758;
			} else {
				if (yych <= 'R') goto yy191;
				if (yych <= 'S') goto yy757;
				goto yy756;
			}
		} else {
			if (yych <= 'r') {
				if (yych == 'l') goto yy758;
				goto yy191;
			} else {
				if (yych <= 's') goto yy757;
				if (yych <= 't') goto yy756;
				goto yy191;
			}
		}
yy736:
		YYDEBUG(736, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych == 'A') goto yy748;
			if (yych <= 'N') goto yy191;
			goto yy749;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy191;
				goto yy748;
			} else {
				if (yych == 'o') goto yy749;
				goto yy191;
			}
		}
yy737:
		YYDEBUG(737, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy738;
		if (yych != 'n') goto yy191;
yy738:
		YYDEBUG(738, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'T') {
			if (yych <= 'R') goto yy191;
			if (yych >= 'T') goto yy740;
		} else {
			if (yych <= 'r') goto yy191;
			if (yych <= 's') goto yy739;
			if (yych <= 't') goto yy740;
			goto yy191;
		}
yy739:
		YYDEBUG(739, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy746;
		if (yych == 't') goto yy746;
		goto yy191;
yy740:
		YYDEBUG(740, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy741;
		if (yych != 'i') goto yy191;
yy741:
		YYDEBUG(741, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy742;
		if (yych != 'n') goto yy191;
yy742:
		YYDEBUG(742, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'U') goto yy743;
		if (yych != 'u') goto yy191;
yy743:
		YYDEBUG(743, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy744;
		if (yych != 'e') goto yy191;
yy744:
		YYDEBUG(744, *YYCURSOR);
		yyaccept = 62;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy745;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy745:
		YYDEBUG(745, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_CONTINUE);
}
yy746:
		YYDEBUG(746, *YYCURSOR);
		yyaccept = 63;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy747;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy747:
		YYDEBUG(747, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_CONST);
}
yy748:
		YYDEBUG(748, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy753;
		if (yych == 's') goto yy753;
		goto yy191;
yy749:
		YYDEBUG(749, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy750;
		if (yych != 'n') goto yy191;
yy750:
		YYDEBUG(750, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy751;
		if (yych != 'e') goto yy191;
yy751:
		YYDEBUG(751, *YYCURSOR);
		yyaccept = 64;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy752;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy752:
		YYDEBUG(752, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_CLONE);
}
yy753:
		YYDEBUG(753, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy754;
		if (yych != 's') goto yy191;
yy754:
		YYDEBUG(754, *YYCURSOR);
		yyaccept = 65;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy755;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy755:
		YYDEBUG(755, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_CLASS);
}
yy756:
		YYDEBUG(756, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy767;
		if (yych == 'c') goto yy767;
		goto yy191;
yy757:
		YYDEBUG(757, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy765;
		if (yych == 'e') goto yy765;
		goto yy191;
yy758:
		YYDEBUG(758, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy759;
		if (yych != 'l') goto yy191;
yy759:
		YYDEBUG(759, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy760;
		if (yych != 'a') goto yy191;
yy760:
		YYDEBUG(760, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'B') goto yy761;
		if (yych != 'b') goto yy191;
yy761:
		YYDEBUG(761, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy762;
		if (yych != 'l') goto yy191;
yy762:
		YYDEBUG(762, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy763;
		if (yych != 'e') goto yy191;
yy763:
		YYDEBUG(763, *YYCURSOR);
		yyaccept = 66;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy764;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy764:
		YYDEBUG(764, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_CALLABLE);
}
yy765:
		YYDEBUG(765, *YYCURSOR);
		yyaccept = 67;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy766;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy766:
		YYDEBUG(766, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_CASE);
}
yy767:
		YYDEBUG(767, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy768;
		if (yych != 'h') goto yy191;
yy768:
		YYDEBUG(768, *YYCURSOR);
		yyaccept = 68;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy769;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy769:
		YYDEBUG(769, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_CATCH);
}
yy770:
		YYDEBUG(770, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy789;
		if (yych == 'n') goto yy789;
		goto yy191;
yy771:
		YYDEBUG(771, *YYCURSOR);
		yyaccept = 69;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy772;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy772:
		YYDEBUG(772, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_FN);
}
yy773:
		YYDEBUG(773, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy782;
		if (yych == 'r') goto yy782;
		goto yy191;
yy774:
		YYDEBUG(774, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy775;
		if (yych != 'n') goto yy191;
yy775:
		YYDEBUG(775, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy776;
		if (yych != 'c') goto yy191;
yy776:
		YYDEBUG(776, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy777;
		if (yych != 't') goto yy191;
yy777:
		YYDEBUG(777, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy778;
		if (yych != 'i') goto yy191;
yy778:
		YYDEBUG(778, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy779;
		if (yych != 'o') goto yy191;
yy779:
		YYDEBUG(779, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy780;
		if (yych != 'n') goto yy191;
yy780:
		YYDEBUG(780, *YYCURSOR);
		yyaccept = 70;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy781;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy781:
		YYDEBUG(781, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_FUNCTION);
}
yy782:
		YYDEBUG(782, *YYCURSOR);
		yyaccept = 71;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= 'D') {
				if (yych <= '/') goto yy783;
				if (yych <= '9') goto yy190;
				if (yych >= 'A') goto yy190;
			} else {
				if (yych <= 'E') goto yy784;
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= 'd') {
				if (yych == '_') goto yy190;
				if (yych >= 'a') goto yy190;
			} else {
				if (yych <= 'e') goto yy784;
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy783:
		YYDEBUG(783, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_FOR);
}
yy784:
		YYDEBUG(784, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy785;
		if (yych != 'a') goto yy191;
yy785:
		YYDEBUG(785, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy786;
		if (yych != 'c') goto yy191;
yy786:
		YYDEBUG(786, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy787;
		if (yych != 'h') goto yy191;
yy787:
		YYDEBUG(787, *YYCURSOR);
		yyaccept = 72;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy788;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy788:
		YYDEBUG(788, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_FOREACH);
}
yy789:
		YYDEBUG(789, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy790;
		if (yych != 'a') goto yy191;
yy790:
		YYDEBUG(790, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy791;
		if (yych != 'l') goto yy191;
yy791:
		YYDEBUG(791, *YYCURSOR);
		yyaccept = 73;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= 'K') {
				if (yych <= '/') goto yy792;
				if (yych <= '9') goto yy190;
				if (yych >= 'A') goto yy190;
			} else {
				if (yych <= 'L') goto yy793;
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= 'k') {
				if (yych == '_') goto yy190;
				if (yych >= 'a') goto yy190;
			} else {
				if (yych <= 'l') goto yy793;
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy792:
		YYDEBUG(792, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_FINAL);
}
yy793:
		YYDEBUG(793, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'Y') goto yy794;
		if (yych != 'y') goto yy191;
yy794:
		YYDEBUG(794, *YYCURSOR);
		yyaccept = 74;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy795;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy795:
		YYDEBUG(795, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_FINALLY);
}
yy796:
		YYDEBUG(796, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'F') {
			if (yych == 'C') goto yy802;
			if (yych <= 'E') goto yy191;
			goto yy803;
		} else {
			if (yych <= 'c') {
				if (yych <= 'b') goto yy191;
				goto yy802;
			} else {
				if (yych == 'f') goto yy803;
				goto yy191;
			}
		}
yy797:
		YYDEBUG(797, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy800;
		if (yych == 'e') goto yy800;
		goto yy191;
yy798:
		YYDEBUG(798, *YYCURSOR);
		yyaccept = 75;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy799;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy799:
		YYDEBUG(799, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_DO);
}
yy800:
		YYDEBUG(800, *YYCURSOR);
		yyaccept = 76;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy801;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy801:
		YYDEBUG(801, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_EXIT);
}
yy802:
		YYDEBUG(802, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy809;
		if (yych == 'l') goto yy809;
		goto yy191;
yy803:
		YYDEBUG(803, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy804;
		if (yych != 'a') goto yy191;
yy804:
		YYDEBUG(804, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'U') goto yy805;
		if (yych != 'u') goto yy191;
yy805:
		YYDEBUG(805, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy806;
		if (yych != 'l') goto yy191;
yy806:
		YYDEBUG(806, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy807;
		if (yych != 't') goto yy191;
yy807:
		YYDEBUG(807, *YYCURSOR);
		yyaccept = 77;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy808;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy808:
		YYDEBUG(808, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_DEFAULT);
}
yy809:
		YYDEBUG(809, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy810;
		if (yych != 'a') goto yy191;
yy810:
		YYDEBUG(810, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy811;
		if (yych != 'r') goto yy191;
yy811:
		YYDEBUG(811, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy812;
		if (yych != 'e') goto yy191;
yy812:
		YYDEBUG(812, *YYCURSOR);
		yyaccept = 78;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy813;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy813:
		YYDEBUG(813, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_DECLARE);
}
yy814:
		YYDEBUG(814, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy899;
		if (yych == 'h') goto yy899;
		goto yy191;
yy815:
		YYDEBUG(815, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy893;
		if (yych == 's') goto yy893;
		goto yy191;
yy816:
		YYDEBUG(816, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'P') goto yy889;
		if (yych == 'p') goto yy889;
		goto yy191;
yy817:
		YYDEBUG(817, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'U') {
			if (yych == 'D') goto yy832;
			if (yych <= 'T') goto yy191;
			goto yy833;
		} else {
			if (yych <= 'd') {
				if (yych <= 'c') goto yy191;
				goto yy832;
			} else {
				if (yych == 'u') goto yy833;
				goto yy191;
			}
		}
yy818:
		YYDEBUG(818, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy829;
		if (yych == 'a') goto yy829;
		goto yy191;
yy819:
		YYDEBUG(819, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'T') {
			if (yych == 'I') goto yy820;
			if (yych <= 'S') goto yy191;
			goto yy821;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy191;
			} else {
				if (yych == 't') goto yy821;
				goto yy191;
			}
		}
yy820:
		YYDEBUG(820, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy827;
		if (yych == 't') goto yy827;
		goto yy191;
yy821:
		YYDEBUG(821, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy822;
		if (yych != 'e') goto yy191;
yy822:
		YYDEBUG(822, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy823;
		if (yych != 'n') goto yy191;
yy823:
		YYDEBUG(823, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy824;
		if (yych != 'd') goto yy191;
yy824:
		YYDEBUG(824, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy825;
		if (yych != 's') goto yy191;
yy825:
		YYDEBUG(825, *YYCURSOR);
		yyaccept = 79;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy826;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy826:
		YYDEBUG(826, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_EXTENDS);
}
yy827:
		YYDEBUG(827, *YYCURSOR);
		yyaccept = 80;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy828;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy828:
		YYDEBUG(828, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_EXIT);
}
yy829:
		YYDEBUG(829, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy830;
		if (yych != 'l') goto yy191;
yy830:
		YYDEBUG(830, *YYCURSOR);
		yyaccept = 81;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy831;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy831:
		YYDEBUG(831, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_EVAL);
}
yy832:
		YYDEBUG(832, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		YYDEBUG(-1, yych);
		switch (yych) {
		case 'D':
		case 'd':	goto yy856;
		case 'F':
		case 'f':	goto yy857;
		case 'I':
		case 'i':	goto yy858;
		case 'S':
		case 's':	goto yy859;
		case 'W':
		case 'w':	goto yy860;
		default:	goto yy191;
		}
yy833:
		YYDEBUG(833, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy834;
		if (yych != 'm') goto yy191;
yy834:
		YYDEBUG(834, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '@') {
			if (yych <= '\r') {
				if (yych <= 0x08) goto yy115;
				if (yych <= '\n') goto yy835;
				if (yych <= '\f') goto yy115;
			} else {
				if (yych <= ' ') {
					if (yych <= 0x1F) goto yy115;
				} else {
					if (yych <= '/') goto yy115;
					if (yych <= '9') goto yy190;
					goto yy115;
				}
			}
		} else {
			if (yych <= '^') {
				if (yych <= 'Z') goto yy190;
				if (yych == '\\') goto yy192;
				goto yy115;
			} else {
				if (yych <= '`') {
					if (yych <= '_') goto yy190;
					goto yy115;
				} else {
					if (yych <= 'z') goto yy190;
					if (yych <= 0x7F) goto yy115;
					goto yy190;
				}
			}
		}
yy835:
		YYDEBUG(835, *YYCURSOR);
		++YYCURSOR;
		YYFILL(10);
		yych = *YYCURSOR;
		YYDEBUG(836, *YYCURSOR);
		if (yych <= 'I') {
			if (yych <= 0x1F) {
				if (yych <= '\n') {
					if (yych <= 0x08) goto yy187;
					goto yy835;
				} else {
					if (yych == '\r') goto yy835;
					goto yy187;
				}
			} else {
				if (yych <= 'D') {
					if (yych <= ' ') goto yy835;
					if (yych <= '@') goto yy187;
				} else {
					if (yych <= 'E') goto yy839;
					if (yych >= 'I') goto yy840;
				}
			}
		} else {
			if (yych <= 'd') {
				if (yych <= '^') {
					if (yych >= '[') goto yy187;
				} else {
					if (yych == '`') goto yy187;
				}
			} else {
				if (yych <= 'i') {
					if (yych <= 'e') goto yy839;
					if (yych >= 'i') goto yy840;
				} else {
					if (yych <= 'z') goto yy837;
					if (yych <= 0x7F) goto yy187;
				}
			}
		}
yy837:
		YYDEBUG(837, *YYCURSOR);
		++YYCURSOR;
yy838:
		YYDEBUG(838, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(4);
	RETURN_TOKEN_WITH_IDENT(T_ENUM);
}
yy839:
		YYDEBUG(839, *YYCURSOR);
		yyaccept = 82;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'X') goto yy851;
		if (yych == 'x') goto yy851;
		goto yy838;
yy840:
		YYDEBUG(840, *YYCURSOR);
		yyaccept = 82;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy841;
		if (yych != 'm') goto yy838;
yy841:
		YYDEBUG(841, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy842;
		if (yych != 'p') goto yy187;
yy842:
		YYDEBUG(842, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy843;
		if (yych != 'l') goto yy187;
yy843:
		YYDEBUG(843, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy844;
		if (yych != 'e') goto yy187;
yy844:
		YYDEBUG(844, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy845;
		if (yych != 'm') goto yy187;
yy845:
		YYDEBUG(845, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy846;
		if (yych != 'e') goto yy187;
yy846:
		YYDEBUG(846, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy847;
		if (yych != 'n') goto yy187;
yy847:
		YYDEBUG(847, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy848;
		if (yych != 't') goto yy187;
yy848:
		YYDEBUG(848, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy849;
		if (yych != 's') goto yy187;
yy849:
		YYDEBUG(849, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(850, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(4);
	RETURN_TOKEN_WITH_STR(T_STRING, 0);
}
yy851:
		YYDEBUG(851, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy852;
		if (yych != 't') goto yy187;
yy852:
		YYDEBUG(852, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy853;
		if (yych != 'e') goto yy187;
yy853:
		YYDEBUG(853, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy854;
		if (yych != 'n') goto yy187;
yy854:
		YYDEBUG(854, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy855;
		if (yych != 'd') goto yy187;
yy855:
		YYDEBUG(855, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy849;
		if (yych == 's') goto yy849;
		goto yy187;
yy856:
		YYDEBUG(856, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy882;
		if (yych == 'e') goto yy882;
		goto yy191;
yy857:
		YYDEBUG(857, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy874;
		if (yych == 'o') goto yy874;
		goto yy191;
yy858:
		YYDEBUG(858, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'F') goto yy872;
		if (yych == 'f') goto yy872;
		goto yy191;
yy859:
		YYDEBUG(859, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'W') goto yy866;
		if (yych == 'w') goto yy866;
		goto yy191;
yy860:
		YYDEBUG(860, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy861;
		if (yych != 'h') goto yy191;
yy861:
		YYDEBUG(861, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy862;
		if (yych != 'i') goto yy191;
yy862:
		YYDEBUG(862, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy863;
		if (yych != 'l') goto yy191;
yy863:
		YYDEBUG(863, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy864;
		if (yych != 'e') goto yy191;
yy864:
		YYDEBUG(864, *YYCURSOR);
		yyaccept = 83;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy865;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy865:
		YYDEBUG(865, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDWHILE);
}
yy866:
		YYDEBUG(866, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy867;
		if (yych != 'i') goto yy191;
yy867:
		YYDEBUG(867, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy868;
		if (yych != 't') goto yy191;
yy868:
		YYDEBUG(868, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy869;
		if (yych != 'c') goto yy191;
yy869:
		YYDEBUG(869, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy870;
		if (yych != 'h') goto yy191;
yy870:
		YYDEBUG(870, *YYCURSOR);
		yyaccept = 84;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy871;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy871:
		YYDEBUG(871, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDSWITCH);
}
yy872:
		YYDEBUG(872, *YYCURSOR);
		yyaccept = 85;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy873;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy873:
		YYDEBUG(873, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDIF);
}
yy874:
		YYDEBUG(874, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy875;
		if (yych != 'r') goto yy191;
yy875:
		YYDEBUG(875, *YYCURSOR);
		yyaccept = 86;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= 'D') {
				if (yych <= '/') goto yy876;
				if (yych <= '9') goto yy190;
				if (yych >= 'A') goto yy190;
			} else {
				if (yych <= 'E') goto yy877;
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= 'd') {
				if (yych == '_') goto yy190;
				if (yych >= 'a') goto yy190;
			} else {
				if (yych <= 'e') goto yy877;
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy876:
		YYDEBUG(876, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDFOR);
}
yy877:
		YYDEBUG(877, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy878;
		if (yych != 'a') goto yy191;
yy878:
		YYDEBUG(878, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy879;
		if (yych != 'c') goto yy191;
yy879:
		YYDEBUG(879, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy880;
		if (yych != 'h') goto yy191;
yy880:
		YYDEBUG(880, *YYCURSOR);
		yyaccept = 87;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy881;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy881:
		YYDEBUG(881, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDFOREACH);
}
yy882:
		YYDEBUG(882, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy883;
		if (yych != 'c') goto yy191;
yy883:
		YYDEBUG(883, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy884;
		if (yych != 'l') goto yy191;
yy884:
		YYDEBUG(884, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy885;
		if (yych != 'a') goto yy191;
yy885:
		YYDEBUG(885, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy886;
		if (yych != 'r') goto yy191;
yy886:
		YYDEBUG(886, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy887;
		if (yych != 'e') goto yy191;
yy887:
		YYDEBUG(887, *YYCURSOR);
		yyaccept = 88;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy888;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy888:
		YYDEBUG(888, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDDECLARE);
}
yy889:
		YYDEBUG(889, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy890;
		if (yych != 't') goto yy191;
yy890:
		YYDEBUG(890, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'Y') goto yy891;
		if (yych != 'y') goto yy191;
yy891:
		YYDEBUG(891, *YYCURSOR);
		yyaccept = 89;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy892;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy892:
		YYDEBUG(892, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_EMPTY);
}
yy893:
		YYDEBUG(893, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy894;
		if (yych != 'e') goto yy191;
yy894:
		YYDEBUG(894, *YYCURSOR);
		yyaccept = 90;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= 'H') {
				if (yych <= '/') goto yy895;
				if (yych <= '9') goto yy190;
				if (yych >= 'A') goto yy190;
			} else {
				if (yych <= 'I') goto yy896;
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= 'h') {
				if (yych == '_') goto yy190;
				if (yych >= 'a') goto yy190;
			} else {
				if (yych <= 'i') goto yy896;
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy895:
		YYDEBUG(895, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ELSE);
}
yy896:
		YYDEBUG(896, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'F') goto yy897;
		if (yych != 'f') goto yy191;
yy897:
		YYDEBUG(897, *YYCURSOR);
		yyaccept = 91;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy898;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy898:
		YYDEBUG(898, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ELSEIF);
}
yy899:
		YYDEBUG(899, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy900;
		if (yych != 'o') goto yy191;
yy900:
		YYDEBUG(900, *YYCURSOR);
		yyaccept = 92;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy901;
				if (yych <= '9') goto yy190;
			} else {
				if (yych <= 'Z') goto yy190;
				if (yych >= '\\') goto yy192;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy190;
			} else {
				if (yych <= 'z') goto yy190;
				if (yych >= 0x80) goto yy190;
			}
		}
yy901:
		YYDEBUG(901, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ECHO);
}
	}
/* *********************************** */
yyc_ST_LOOKING_FOR_PROPERTY:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128,   0,   0, 128,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,   0,   0,   0,   0,   0,   0, 
			  0,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,   0,   0,   0,   0,  64, 
			  0,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,   0,   0,   0,   0,   0, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
		};
		YYDEBUG(902, *YYCURSOR);
		YYFILL(3);
		yych = *YYCURSOR;
		if (yych <= '>') {
			if (yych <= '\r') {
				if (yych <= 0x08) goto yy911;
				if (yych <= '\n') goto yy904;
				if (yych <= '\f') goto yy911;
			} else {
				if (yych <= ' ') {
					if (yych <= 0x1F) goto yy911;
				} else {
					if (yych == '-') goto yy906;
					goto yy911;
				}
			}
		} else {
			if (yych <= '^') {
				if (yych <= '?') goto yy908;
				if (yych <= '@') goto yy911;
				if (yych <= 'Z') goto yy909;
				goto yy911;
			} else {
				if (yych <= '`') {
					if (yych <= '_') goto yy909;
					goto yy911;
				} else {
					if (yych <= 'z') goto yy909;
					if (yych <= 0x7F) goto yy911;
					goto yy909;
				}
			}
		}
yy904:
		YYDEBUG(904, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy921;
yy905:
		YYDEBUG(905, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	goto return_whitespace;
}
yy906:
		YYDEBUG(906, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '>') goto yy918;
yy907:
		YYDEBUG(907, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(0);
	yy_pop_state();
	goto restart;
}
yy908:
		YYDEBUG(908, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '-') goto yy914;
		goto yy907;
yy909:
		YYDEBUG(909, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy913;
yy910:
		YYDEBUG(910, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_pop_state();
	RETURN_TOKEN_WITH_STR(T_STRING, 0);
}
yy911:
		YYDEBUG(911, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy907;
yy912:
		YYDEBUG(912, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy913:
		YYDEBUG(913, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy912;
		}
		goto yy910;
yy914:
		YYDEBUG(914, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy916;
		YYDEBUG(915, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy907;
yy916:
		YYDEBUG(916, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(917, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_NULLSAFE_OBJECT_OPERATOR);
}
yy918:
		YYDEBUG(918, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(919, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_OBJECT_OPERATOR);
}
yy920:
		YYDEBUG(920, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy921:
		YYDEBUG(921, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy920;
		}
		goto yy905;
	}
/* *********************************** */
yyc_ST_LOOKING_FOR_VARNAME:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(922, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy926;
			if (yych <= 'Z') goto yy924;
			if (yych <= '^') goto yy926;
		} else {
			if (yych <= '`') goto yy926;
			if (yych <= 'z') goto yy924;
			if (yych <= 0x7F) goto yy926;
		}
yy924:
		YYDEBUG(924, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '_') {
			if (yych <= '@') {
				if (yych <= '/') goto yy925;
				if (yych <= '9') goto yy928;
			} else {
				if (yych <= '[') goto yy928;
				if (yych >= '_') goto yy928;
			}
		} else {
			if (yych <= '|') {
				if (yych <= '`') goto yy925;
				if (yych <= 'z') goto yy928;
			} else {
				if (yych <= '}') goto yy928;
				if (yych >= 0x80) goto yy928;
			}
		}
yy925:
		YYDEBUG(925, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(0);
	yy_pop_state();
	yy_push_state(ST_IN_SCRIPTING);
	goto restart;
}
yy926:
		YYDEBUG(926, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy925;
yy927:
		YYDEBUG(927, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy928:
		YYDEBUG(928, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy927;
		}
		if (yych <= '@') goto yy929;
		if (yych <= '[') goto yy930;
		if (yych == '}') goto yy930;
yy929:
		YYDEBUG(929, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy925;
yy930:
		YYDEBUG(930, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(931, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 1);
	yy_pop_state();
	yy_push_state(ST_IN_SCRIPTING);
	RETURN_TOKEN_WITH_STR(T_STRING_VARNAME, 0);
}
	}
/* *********************************** */
yyc_ST_NOWDOC:
	YYDEBUG(932, *YYCURSOR);
	YYFILL(1);
	yych = *YYCURSOR;
	YYDEBUG(934, *YYCURSOR);
	++YYCURSOR;
	YYDEBUG(935, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
	{
	zend_heredoc_label *heredoc_label = zend_ptr_stack_top(&SCNG(heredoc_label_stack));
	int newline = 0, indentation = 0, spacing = -1;

	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}

	YYCURSOR--;

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '\r':
				if (*YYCURSOR == '\n') {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			case '\n':
				indentation = spacing = 0;

				while (YYCURSOR < YYLIMIT && (*YYCURSOR == ' ' || *YYCURSOR == '\t')) {
					if (*YYCURSOR == '\t') {
						spacing |= HEREDOC_USING_TABS;
					} else {
						spacing |= HEREDOC_USING_SPACES;
					}
					++YYCURSOR;
					++indentation;
				}

				if (YYCURSOR == YYLIMIT) {
					yyleng = YYCURSOR - SCNG(yy_text);
					HANDLE_NEWLINES(yytext, yyleng);
					ZVAL_NULL(zendlval);
					RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
				}

				/* Check for ending label on the next line */
				if (IS_LABEL_START(*YYCURSOR) && heredoc_label->length < YYLIMIT - YYCURSOR && !memcmp(YYCURSOR, heredoc_label->label, heredoc_label->length)) {
					if (IS_LABEL_SUCCESSOR(YYCURSOR[heredoc_label->length])) {
						continue;
					}

					if (spacing == (HEREDOC_USING_SPACES | HEREDOC_USING_TABS)) {
						zend_throw_exception(zend_ce_parse_error, "Invalid indentation - tabs and spaces cannot be mixed", 0);
						if (PARSER_MODE()) {
							RETURN_TOKEN(T_ERROR);
						}
					}

					/* newline before label will be subtracted from returned text, but
					 * yyleng/yytext will include it, for zend_highlight/strip, tokenizer, etc. */
					if (YYCURSOR[-indentation - 2] == '\r' && YYCURSOR[-indentation - 1] == '\n') {
						newline = 2; /* Windows newline */
					} else {
						newline = 1;
					}

					CG(increment_lineno) = 1; /* For newline before label */

					YYCURSOR -= indentation;
					heredoc_label->indentation = indentation;

					BEGIN(ST_END_HEREDOC);

					goto nowdoc_scan_done;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}
	}

nowdoc_scan_done:
	yyleng = YYCURSOR - SCNG(yy_text);
	ZVAL_STRINGL(zendlval, yytext, yyleng - newline);

	if (!EG(exception) && spacing != -1 && PARSER_MODE()) {
		bool newline_at_start = *(yytext - 1) == '\n' || *(yytext - 1) == '\r';
		if (!strip_multiline_string_indentation(
				zendlval, indentation, spacing == HEREDOC_USING_SPACES,
				newline_at_start, newline != 0)) {
			RETURN_TOKEN(T_ERROR);
		}
	}

	HANDLE_NEWLINES(yytext, yyleng - newline);
	RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
}
/* *********************************** */
yyc_ST_VAR_OFFSET:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			248, 248, 184, 184, 184, 184, 184, 184, 
			 56,  56,   0,   0,   0,   0,   0,   0, 
			  0,  40,  40,  40,  40,  40,  40,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   0,   0,   0,   0,   8, 
			  0,  40,  40,  40,  40,  40,  40,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   0,   0,   0,   0,   0, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
		};
		YYDEBUG(936, *YYCURSOR);
		YYFILL(3);
		yych = *YYCURSOR;
		if (yych <= '0') {
			if (yych <= ' ') {
				if (yych <= '\f') {
					if (yych <= 0x08) goto yy950;
					if (yych <= '\n') goto yy946;
					goto yy950;
				} else {
					if (yych <= '\r') goto yy946;
					if (yych <= 0x1F) goto yy950;
					goto yy946;
				}
			} else {
				if (yych <= '$') {
					if (yych <= '"') goto yy945;
					if (yych <= '#') goto yy946;
					goto yy941;
				} else {
					if (yych == '\'') goto yy946;
					if (yych <= '/') goto yy945;
				}
			}
		} else {
			if (yych <= ']') {
				if (yych <= 'Z') {
					if (yych <= '9') goto yy940;
					if (yych <= '@') goto yy945;
					goto yy948;
				} else {
					if (yych <= '[') goto yy945;
					if (yych <= '\\') goto yy946;
					goto yy943;
				}
			} else {
				if (yych <= '`') {
					if (yych == '_') goto yy948;
					goto yy945;
				} else {
					if (yych <= 'z') goto yy948;
					if (yych <= '~') goto yy945;
					if (yych <= 0x7F) goto yy950;
					goto yy948;
				}
			}
		}
		YYDEBUG(938, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'X') {
			if (yych <= 'B') {
				if (yych <= '/') goto yy939;
				if (yych <= '9') goto yy967;
				if (yych >= 'B') goto yy965;
			} else {
				if (yych == 'O') goto yy964;
				if (yych >= 'X') goto yy966;
			}
		} else {
			if (yych <= 'b') {
				if (yych == '_') goto yy957;
				if (yych >= 'b') goto yy965;
			} else {
				if (yych <= 'o') {
					if (yych >= 'o') goto yy964;
				} else {
					if (yych == 'x') goto yy966;
				}
			}
		}
yy939:
		YYDEBUG(939, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{ /* Offset could be treated as a long */
	if (yyleng < MAX_LENGTH_OF_LONG - 1 || (yyleng == MAX_LENGTH_OF_LONG - 1 && strcmp(yytext, long_min_digits) < 0)) {
		char *end;
		errno = 0;
		ZVAL_LONG(zendlval, ZEND_STRTOL(yytext, &end, 10));
		if (errno == ERANGE) {
			goto string;
		}
		ZEND_ASSERT(end == yytext + yyleng);
	} else {
string:
		ZVAL_STRINGL(zendlval, yytext, yyleng);
	}
	RETURN_TOKEN_WITH_VAL(T_NUM_STRING);
}
yy940:
		YYDEBUG(940, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		goto yy960;
yy941:
		YYDEBUG(941, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '_') {
			if (yych <= '@') goto yy942;
			if (yych <= 'Z') goto yy954;
			if (yych >= '_') goto yy954;
		} else {
			if (yych <= '`') goto yy942;
			if (yych <= 'z') goto yy954;
			if (yych >= 0x80) goto yy954;
		}
yy942:
		YYDEBUG(942, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	/* Only '[' or '-' can be valid, but returning other tokens will allow a more explicit parse error */
	RETURN_TOKEN(yytext[0]);
}
yy943:
		YYDEBUG(943, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(944, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_pop_state();
	RETURN_TOKEN(']');
}
yy945:
		YYDEBUG(945, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy942;
yy946:
		YYDEBUG(946, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(947, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	/* Invalid rule to return a more explicit parse error with proper line number */
	yyless(0);
	yy_pop_state();
	ZVAL_NULL(zendlval);
	RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
}
yy948:
		YYDEBUG(948, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy953;
yy949:
		YYDEBUG(949, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_STRING, 0);
}
yy950:
		YYDEBUG(950, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(951, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}

	RETURN_TOKEN(T_BAD_CHARACTER);
}
yy952:
		YYDEBUG(952, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy953:
		YYDEBUG(953, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy952;
		}
		goto yy949;
yy954:
		YYDEBUG(954, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(955, *YYCURSOR);
		if (yych <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy954;
			} else {
				if (yych <= '@') goto yy956;
				if (yych <= 'Z') goto yy954;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy954;
			} else {
				if (yych <= 'z') goto yy954;
				if (yych >= 0x80) goto yy954;
			}
		}
yy956:
		YYDEBUG(956, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy957:
		YYDEBUG(957, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy958;
		if (yych <= '9') goto yy961;
yy958:
		YYDEBUG(958, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept == 0) {
			goto yy939;
		} else {
			goto yy963;
		}
yy959:
		YYDEBUG(959, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy960:
		YYDEBUG(960, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy959;
		}
		if (yych == '_') goto yy957;
		goto yy939;
yy961:
		YYDEBUG(961, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(962, *YYCURSOR);
		if (yych <= '/') goto yy963;
		if (yych <= '9') goto yy961;
		if (yych == '_') goto yy957;
yy963:
		YYDEBUG(963, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{ /* Offset must be treated as a string */
	if (yyleng == 1) {
		ZVAL_INTERNED_STR(zendlval, ZSTR_CHAR((zend_uchar)*(yytext)));
	} else {
		ZVAL_STRINGL(zendlval, yytext, yyleng);
	}
	RETURN_TOKEN_WITH_VAL(T_NUM_STRING);
}
yy964:
		YYDEBUG(964, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 128) {
			goto yy979;
		}
		goto yy958;
yy965:
		YYDEBUG(965, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 64) {
			goto yy974;
		}
		goto yy958;
yy966:
		YYDEBUG(966, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy969;
		}
		goto yy958;
yy967:
		YYDEBUG(967, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(968, *YYCURSOR);
		if (yych <= '/') goto yy963;
		if (yych <= '9') goto yy967;
		if (yych == '_') goto yy957;
		goto yy963;
yy969:
		YYDEBUG(969, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(970, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy969;
		}
		if (yych != '_') goto yy963;
yy971:
		YYDEBUG(971, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '@') {
			if (yych <= '/') goto yy958;
			if (yych >= ':') goto yy958;
		} else {
			if (yych <= 'F') goto yy972;
			if (yych <= '`') goto yy958;
			if (yych >= 'g') goto yy958;
		}
yy972:
		YYDEBUG(972, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(973, *YYCURSOR);
		if (yych <= 'F') {
			if (yych <= '/') goto yy963;
			if (yych <= '9') goto yy972;
			if (yych <= '@') goto yy963;
			goto yy972;
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy963;
				goto yy971;
			} else {
				if (yych <= '`') goto yy963;
				if (yych <= 'f') goto yy972;
				goto yy963;
			}
		}
yy974:
		YYDEBUG(974, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(975, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy974;
		}
		if (yych != '_') goto yy963;
yy976:
		YYDEBUG(976, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy958;
		if (yych >= '2') goto yy958;
yy977:
		YYDEBUG(977, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(978, *YYCURSOR);
		if (yych <= '/') goto yy963;
		if (yych <= '1') goto yy977;
		if (yych == '_') goto yy976;
		goto yy963;
yy979:
		YYDEBUG(979, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(980, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy979;
		}
		if (yych != '_') goto yy963;
yy981:
		YYDEBUG(981, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy958;
		if (yych >= '8') goto yy958;
yy982:
		YYDEBUG(982, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(983, *YYCURSOR);
		if (yych <= '/') goto yy963;
		if (yych <= '7') goto yy982;
		if (yych == '_') goto yy981;
		goto yy963;
	}
}


emit_token_with_str:
	zend_copy_value(zendlval, (yytext + offset), (yyleng - offset));

emit_token_with_val:
	if (PARSER_MODE()) {
		ZEND_ASSERT(Z_TYPE_P(zendlval) != IS_UNDEF);
		elem->ast = zend_ast_create_zval_with_lineno(zendlval, start_line);
	}

emit_token:
	if (SCNG(on_event)) {
		SCNG(on_event)(ON_TOKEN, token, start_line, yytext, yyleng, SCNG(on_event_context));
	}
	return token;

emit_token_with_ident:
	if (PARSER_MODE()) {
		elem->ident = SCNG(yy_text);
	}
	if (SCNG(on_event)) {
		SCNG(on_event)(ON_TOKEN, token, start_line, yytext, yyleng, SCNG(on_event_context));
	}
	return token;

return_whitespace:
	HANDLE_NEWLINES(yytext, yyleng);
	if (SCNG(on_event)) {
		SCNG(on_event)(ON_TOKEN, T_WHITESPACE, start_line, yytext, yyleng, SCNG(on_event_context));
	}
	if (PARSER_MODE()) {
		start_line = CG(zend_lineno);
		goto restart;
	} else {
		return T_WHITESPACE;
	}

skip_token:
	if (SCNG(on_event)) {
		SCNG(on_event)(ON_TOKEN, token, start_line, yytext, yyleng, SCNG(on_event_context));
	}
	start_line = CG(zend_lineno);
	goto restart;
}
